# validate output for prep
# initialize values

#set box .a
#catch {destroy ${box}}
#catch {unset extinctlbl}
#pack [frame ${box}]
#wm title . "Prep input"

#Centering
set extinctlbl(t1) Centering
set extinctlbl(1) {   None     {A (k+l=2n)}    {B (h+l=2n)}    {C (h+k=2n)} \
	{F (h+k,h+l,k+l=2n)}     {I (h+k+l=2n)}    {R-OBVERSE (-h+k+l=3n)} \
	{R-REVERSE (h-k+l=3n)}    {HEXAGONAL (h-k=3n)} }

# (hk0) ZONE - glides _|_ c
set extinctlbl(t2) "Glides _|_ to C (hk0)"
set extinctlbl(2) {    none    {A (h=2n)}    {B (k=2n)}    {N (h+k=2n)} \
	{D (h+k=4n;h,k=2n)} }

# (h0l) ZONE - glides _|_ b
set extinctlbl(t3) "Glides _|_ to B (h0l)"
set extinctlbl(3) {    none    {A (h=2n)}    {C (l=2n)}    {N (h+l=2n)} \
	{D (h+l=4n;h,l=2n)} }

# (0kl) ZONE - glides _|_ a
set extinctlbl(t4) "Glides _|_ to A (0kl)"
set extinctlbl(4) {    none    {B (k=2n)}    {C (l=2n)}    {N (k+l=2n)} \
	{D (k+l=4n;k,l=2n)} }

# (hhl) ZONE - glides _|_ a+b
set extinctlbl(t5) "Glides _|_ to A+B (hhl)"
set extinctlbl(5) {    none   {C(N) (l=2n)} {D (2h+l=4n)} }

# (-hhl) ZONE - glides _|_ a-b
set extinctlbl(t6) "Glides _|_ to A-B (-hhl)"
set extinctlbl(6) {    none   {C(N) (l=2n)} {D (2h+l=4n)} }

# (hkh) ZONE - glides _|_ a+c
set extinctlbl(t7) "Glides _|_ to A+C (hkh)"
set extinctlbl(7) {    none   {B(N) (k=2n)} {D (2h+k=4n)} }

# (-hkh) ZONE - glides _|_ a-c
set extinctlbl(t8) "Glides _|_ to A-C (-hkh)"
set extinctlbl(8) {    none   {B(N) (k=2n)} {D (2h+k=4n)} }

# (hkk) ZONE - glides _|_ b+c
set extinctlbl(t9) "Glides _|_ to B+C (hkk)"
set extinctlbl(9) {    none   {A(N) (h=2n)} {D (h+2k=4n)} }

# (hk-k) ZONE - glides _|_ b-c
set extinctlbl(t10) "Glides _|_ to B-C (hk-k)"
set extinctlbl(10) {    none  {A(N) (h=2n)} {D (h+2k=4n)} }

# (h00) row - screw axes along a
set extinctlbl(t11) {screw axis || a (h00)}
set extinctlbl(11) {    none {21 or 42 (h=2n)} {41 or 43 (h=4n) } }
# (0k0) row - screw axes along b
set extinctlbl(t12) {screw axis || b (0k0)}
set extinctlbl(12) {    none {21 or 42 (k=2n)} {41 or 43 (k=4n) } }
# (00l) row - screw axes along c
set extinctlbl(t13) {screw axis || c (00l)}
set extinctlbl(13) {    none {21 or 42 (l=2n)} {31 32 62 or 64 (l=3n)} \
	{41 or 43 (l=4n)} {61 or 65 (l=6n)} }

set extinctlbl(lauetbl) {\
	-1 \
	"2/m (y unique)" "2/m (z unique)" \
	mmm \
	4/m 4/mmm \
	m3 m3m \
	"-3 (rhom cell)" "-3m (rhom cell)" \
	"-3 (hex cell)" "-3m (hex cell)" \
	6/m 6/mmm "-3 rotated (hex)"}

proc resetextinctions {} {
    global extinctlbl
    for {set num 1} {$num < 14} {incr num} {
	set extinctlbl(r$num) [lindex $extinctlbl($num) 0]
    }
}
proc symbox {box num} {
    global extinctlbl
    pack [label $box.l -text $extinctlbl(t$num) -width 20] 
    eval tk_optionMenu $box.m extinctlbl(r$num) $extinctlbl($num)
    pack $box.m
}
# create an extintion menu
proc extinctmenu {top} {
    set rowlist {0 1 2 3 4}
    set columnlist {1 {11 12 13} {4 3 2} {5 6 7} {8 9 10}}
    foreach row $rowlist {
	pack [frame $top.$row] -side top
	foreach column [lindex $columnlist $row] {
	    pack [frame $top.$row.$column] -side left
	    symbox $top.$row.$column $column
	}
    }
    pack [frame $top.6] -side top -fill both
}

proc makecellbox {topbox title} {
    global cellparm
    set cellparm(top) $topbox
    grid [label $topbox.head -text $title] -column 0 -row 0 -columnspan 4
    set col 0
    set row 0
    foreach var {a b c} {
	grid [label $topbox.l$var -anchor e -text $var] \
		-column $col -row [incr row]
	grid [entry $topbox.e$var \
		-width 10 -relief sunken -bd 2 -textvariable cellparm($var)] \
		-column [expr 1+$col] -row $row
    }
    set col 2
    set row 0
    foreach var {alpha beta gamma} lbl {a b g} {
	grid [label $topbox.l$var -anchor e -text $lbl -font symbol] \
		-column $col -row [incr row]
	grid [entry $topbox.e$var \
		-width 10 -relief sunken -bd 2 -textvariable cellparm($var)] \
		-column [expr 1+$col] -row $row
    }
}
######################################################################
# set allowed cell parameters as called by setcellsym
######################################################################
proc setcellbox {fix lock} {
    global cellparm
    set topbox $cellparm(top)
    # reset all entries
    set i -1
    foreach var {a b c alpha beta gamma} {
	incr i
	$topbox.e$var config -state normal -fg black -textvariable cellparm($var)
	$topbox.l$var config -fg black
	# variables to fix
	if {[lindex $fix $i]-0 > 0} {
	    set cellparm($var) [lindex $fix $i]
	    $topbox.e$var config -state disabled -fg #808080
	    $topbox.l$var config -fg #808080
	}
	if {"[lindex $lock $i]" != ""} {
	    $topbox.e$var config -fg #888 -textvariable cellparm([lindex $lock $i])
	    $topbox.l$var config -fg #888
	}
    }
}
######################################################################
# set allowed cell parameters based on Laue class
#      calls setproc (set by call to makesymbox)
######################################################################
proc setcellsym {laue setproc} {
    switch $laue {
	1 { $setproc {0 0 0 0 0 0} {} }
	2 { $setproc {0 0 0 90 0 90} {} }
	3 { $setproc {0 0 0 90 90 0} {} }
	4 { $setproc {0 0 0 90 90 90} {} }
	5 -
	6 { $setproc {0 0 0 90 90 90} {"" a} }
	7 -
	8 { $setproc {0 0 0 90 90 90} {"" a a} }
	9 -
	10 { $setproc {0 0 0 0 0 0} {"" a a "" alpha alpha} }
	11 -
	12 -
	13 -
	14 -
	15 { $setproc {0 0 0 90 90 120} {"" a} }
    }
}

proc prepbox {box} {
    global prep extinctlbl cellparm
    catch {eval destroy [grid slaves $box]}

    frame ${box}.0
    grid [label ${box}.0.ltitle -text Title] -row 1 -column 1
    grid [entry ${box}.0.etitle -textvariable prep(title) -width 60] \
	-row 1 -column 2 -columnspan 8
    frame ${box}.1 
    frame ${box}.2 -relief groove -height 10 -width 10 -bd 4
    frame ${box}.3 -relief groove -height 10 -width 10 -bd 4
    foreach n {0 1 2 3} {
	grid ${box}.$n -column 0 -row $n -sticky ew
    }
    #pack ${box}.1 ${box}.2 ${box}.3 -side top -expand yes -fill both
    resetextinctions
    extinctmenu ${box}.2 

    eval tk_optionMenu ${box}.1.laue extinctlbl(laue) $extinctlbl(lauetbl)
    set extinctlbl(laue) {}
    grid [label ${box}.1.l -text "Laue group"]      -column 0 -row 0
    grid ${box}.1.laue                              -column 0 -row 1 
    grid [frame ${box}.1.f -bd 4 -relief groove]    -column 0 -row 2 -rowspan 3
    makecellbox ${box}.1.f "Cell parameters"
    grid [button ${box}.1.ex -text "Edit Excluded Regions" \
	    -command {catch {toplevel .edit}; EditExcluded .edit} \
	    ] -column 0 -row 5
    
    grid [frame ${box}.1.f1t -bd 4 -relief groove]  -column 1 -row 0 -rowspan 3 -sticky new
    grid [frame ${box}.1.m -bd 4 -relief groove]    -column 1 -row 3 -rowspan 2

    grid [frame ${box}.1.f1p -bd 4 -relief groove]  -column 2 -row 2 -rowspan 4 -sticky n
    grid [frame ${box}.1.det -bd 4 -relief groove]  -column 2 -row 0 -rowspan 2 -sticky ew

    set row 0
    foreach var {u v w} {
	grid [\
		label ${box}.1.f1t.l$var -text [string toupper $var] \
		] -row $row -column 0 
	grid [\
		entry ${box}.1.f1t.e$var -textvariable prep($var) -width 8 \
		] -row $row -column 1 -sticky w
	incr row
    }
    grid columnconfigure ${box}.1.f1t 0 -weight 1
    set row 0
    foreach var {2tM 2tZ wave} \
	    label {"2theta\nmax" "2theta\nzero" wavelength} {
	grid [\
		label ${box}.1.f1p.l$var -text $label \
		] -row $row -column 0
	grid [\
		entry ${box}.1.f1p.e$var -textvariable prep($var) -width 9 \
		] -row $row -column 1
	incr row
    }
    set cellparm(magbox) ${box}.1.m
    grid [checkbutton ${box}.1.m.imag -variable prep(imag) \
	    -command EnableEntry \
	    -text "Magnetic\nScattering"] -column 0 -row 0 -columnspan 2
    grid [label ${box}.1.m.l -text "Magnetic\n2theta\nmax."] -column 0 -row 1
    grid [entry ${box}.1.m.tthmag -textvariable prep(tthmag) -width 10] -column 1 -row 1 
    grid [label ${box}.1.det.l -text "Detector range"] -column 0 -row 0 -columnspan 4
    grid [label ${box}.1.det.l1 -text "1st"] -column 0 -row 1 
    grid [label ${box}.1.det.l2 -text "last"] -column 2 -row 1 
    grid [entry ${box}.1.det.e1 -width 3 \
	    -textvariable prep(dets) ] -column 1 -row 1 
    grid [entry ${box}.1.det.e2 -width 3 \
	    -textvariable prep(detl)] -column 4 -row 1 
    grid [button ${box}.3.b -text "Run Prep" \
	    -command "RunPrep $box"] -column 1 -row 1
    grid [button ${box}.3.q -text Quit \
	    -command "buttonbar $box"] -column 2 -row 1
}

proc setlaue {args} {
    global extinctlbl
    catch {
	setcellsym [\
		expr 1+[lsearch $extinctlbl(lauetbl) $extinctlbl(laue)]] \
		setcellbox
    }
}

proc init_prep {mono col} {
    global cellparm prep extinctlbl
    set prep(2tM)    180.0
    set prep(2tZ)    0.0
    set prep(detl)   32
    set prep(dets)   1
    set prep(imag)   0
    set extinctlbl(laue) {}
    switch [string toupper $mono-$col] {
	GE311-15 {
	    set prep(u)      2000.00
	    set prep(v)      1000.00
	    set prep(w)      4000.00
	    set prep(tthmag) 100
	}
	GE311-7 {
	    set prep(u)      2000.00
	    set prep(v)      1000.00
	    set prep(w)      4000.00
	    set prep(tthmag) 100
	}
	CU311-15 {
	    set prep(u)      2000.00
	    set prep(v)      1000.00
	    set prep(w)      4000.00
	    set prep(tthmag) 70
	}
	CU311-7 {
	    set prep(u)      2000.00
	    set prep(v)      1000.00
	    set prep(w)      4000.00
	    set prep(tthmag) 70
	}
	SI531-15 {
	    set prep(u)      2000.00
	    set prep(v)      1000.00
	    set prep(w)      4000.00
	    set prep(tthmag) 70
	}
	SI531-7 {
	    set prep(u)      2000.00
	    set prep(v)      1000.00
	    set prep(w)      4000.00
	    set prep(tthmag) 70
	}
    }
}


proc read_ctl {} {
    global cellparm prep extinctlbl
    set root $prep(rootname)
    set box $cellparm(top)

    if [file exists $root.CTL] {
	set fp [open $root.CTL r]
	gets $fp prep(title)
	gets $fp line
	set box $cellparm(top)
	foreach val $line \
		var {a b c alpha beta gamma} {
	    ${box}.e$var delete 0 end
	    ${box}.e$var insert 0 $val
	}
	gets $fp line
	foreach val $line var {wave 2tM} {
	    set prep($var) $val
	}
	gets $fp line
	foreach val $line \
		num {laue 1 2 3 4 5 6 7 8 9 10 11 12 13 } {
	    if {$num == "laue"} {
		set extinctlbl(laue) [lindex $extinctlbl(lauetbl) [expr $val -1]]
	    } else {
		set extinctlbl(r$num) [lindex $extinctlbl($num) $val]
	    }
	}
	gets $fp line
	#--------  imag = 0 non-magnetic
	set prep(imag) [lindex $line 0]
	#-------- tthmag maximum 2theta for magnetic contribution (90 resonab. def)
	set prep(tthmag)  [lindex $line 1]
	gets $fp line
	foreach val $line \
		var {u v w 2tZ} {
	    set prep($var) $val
	}
	gets $fp line
	set prep(step) 0.05
	catch {
	    set prep(step) [expr $line / 100.]
	}
	# excluded regions (2I8) ttmin ttmax (centidegrees)
	set i 0
	while {[gets $fp line] >= 0} {
	    incr i
	    set prep(ttmin$i) [expr [lindex $line 0] / 100.]
	    set prep(ttmax$i) [expr [lindex $line 1] / 100.]
	}
	close $fp
    }
    if [file exists $root.DET] {
	set fp [open $root.DET r]
	gets $fp line
	set prep(dets) [lindex $line 1]
	set prep(detl) [lindex $line 2]
	close $fp
    }
    # after initialization
    EnableEntry
}

proc write_ctl {} {
    global cellparm prep

    set root $prep(rootname)

    catch {file rename $root.CTL $root.CTL.last}
    set fp [open $root.CTL w]
    puts $fp $prep(title)
    # cell
    set box $cellparm(top)
    set line {}
    foreach var {a b c alpha beta gamma} {
	lappend line [${box}.e$var get]
    }
    puts $fp [eval format %12f%12f%12f%12f%12f%12f $line]

    puts $fp [eval format %12f%12f $prep(wave) $prep(2tM)]

    global extinctlbl
    set line [format %3d [expr 1+[lsearch $extinctlbl(lauetbl) $extinctlbl(laue)]]]
    for {set num 1} {$num < 14} {incr num} {
	append line [format %3d [lsearch $extinctlbl($num) $extinctlbl(r$num)]]
    }
    puts $fp $line
    puts $fp [eval format %2d%10f $prep(imag) $prep(tthmag)]

    puts $fp [eval format %8.2f%8.2f%8.2f%8.4f $prep(u) $prep(v) $prep(w) $prep(2tZ)]

    puts $fp [eval format %8d [expr int($prep(step)*100)]]

    # excluded regions (2I8) ttmin ttmax (centidegrees)
    set flag 0
    catch {
	for {set i 1} {$i < 20} {incr i} {
	    puts $fp [eval format %8d%8d \
		    [expr int($prep(ttmin$i)*100)] \
		    [expr int($prep(ttmax$i)*100)] \
		    ]
	    if {$prep(ttmin$i) < 0 || $prep(ttmax$i) < 0} {
		set flag 1
		break
	    }
	}
	if {!$flag} {puts $fp [eval format %8d%8d -100 -100]}
    }
    close $fp
    set fp [open $root.DET w]
    puts $fp "\"detector range:\" $prep(dets) $prep(detl)"
    close $fp
}

proc EnableEntry {} {
    global prep cellparm
    if {$prep(imag) == 0} {
	$cellparm(magbox).l config -fg gray
	$cellparm(magbox).tthmag config -state disabled -fg gray
    } else {
	$cellparm(magbox).l config -fg black
	$cellparm(magbox).tthmag config -state normal -fg black
    }
}

proc EditExcluded {cantop} {
    global prep
    wm title $cantop "Edit Excluded Regions"
    if {$cantop == ""} {set canpar .} else {set canpar $cantop}
    catch {eval destroy [grid slaves $canpar]}
    raise $cantop 
    bind $cantop <Control-KeyPress-c> "destroy $cantop"
    grid [canvas $cantop.c \
	    -scrollregion {0 0 5000 500} -width 500 -height 350] \
	    -sticky  news -row 1 -column 1
    grid [scrollbar $cantop.yscroll -orient vertical] \
	    -sticky ns -row 1 -column 2
    grid [scrollbar $cantop.xscroll -orient horizontal] \
	    -sticky ew -row 2 -column 1
    grid [label $cantop.l \
	    -text "Edit Excluded Regions (degrees)"] \
	    -column 1 -columnspan 2 -row 0 -sticky w
    $cantop.c config \
	    -yscrollcommand "$cantop.yscroll set" \
	    -xscrollcommand "$cantop.xscroll set"
    $cantop.yscroll config -command \
	    "$cantop.c yview"
    $cantop.xscroll config -command \
	    "$cantop.c xview"
    grid columnconfigure $canpar 2 -weight 1
    grid rowconfigure $canpar 1 -weight 1
    grid [frame $cantop.but] -column 1 -row 3 -sticky w
    grid [button $cantop.but.add -text "Add" \
	    -command "EditExcluded $cantop"] \
	    -column 0 -row 0 -sticky w
    grid [button $cantop.but.quit -text "Close" \
	    -command "destroy $cantop"] \
	    -column 1 -row 0 -sticky w
    # create a frame to hold the terms
    frame $cantop.c.f
    $cantop.c create window 0 0 -anchor nw -window $cantop.c.f
    set flag 1
    set i 0
    while {$flag && $i < 19} {
	incr i
	if [catch {set prep(ttmin$i)}] {set prep(ttmin$i) -1.}
	if [catch {set prep(ttmax$i)}] {set prep(ttmax$i) -1.}
	if {$prep(ttmin$i) < 0 || $prep(ttmax$i) < 0} {set flag 0}
        grid [label $cantop.c.f.la$i -text "$i    Minimum:"] -column 0 -row $i
        grid [entry $cantop.c.f.le$i -textvariable prep(ttmin$i) \
		-width 8] -column 1 -row $i
        grid [label $cantop.c.f.lb$i -text "  Maximum:"] -column 2 -row $i
        grid [entry $cantop.c.f.lf$i -textvariable prep(ttmax$i) \
		-width 8] -column 3 -row $i
    }
    # resize the scroll window to match the actual
    update idletasks
    $cantop.c config -scrollregion [grid bbox $cantop.c.f]
    update idletasks
}

trace variable extinctlbl(laue) w setlaue

# called to load a prep file
proc LoadPrep {top} {
    global prep in ref cellparm
    # need the dialog 1st
    prepbox $top
    read_ctl 
    # here we need to update with values from the .OLD/.PRM file
    if [CopyFromRefineFile $prep(rootname)] {
	set prep(title) $in(title)
	set prep(wave) $in(LAMBDA)
	set prep(2tZ) $in(Z)
	if {$in(DIR) == 1} {
	    foreach var {a b c alpha beta gamma} \
		    digits {6 6 6 3 3 3} \
		    val [DirectCell $in(A) $in(B) $in(C) $in(D) $in(E) $in(F)] {
		set cellparm($var) [format %.${digits}f $val]
	    }
	} else {
	    foreach var {a b c alpha beta gamma} \
		    digits {6 6 6 3 3 3} \
		    val "$in(A) $in(B) $in(C) $in(D) $in(E) $in(F)" {
		set cellparm($var) [format %.${digits}f $val]
	    }
	}
#	set prep() $in()
#	set prep() $in()
    }
}

proc RunPrep {top} {
    global prep refgui
    write_ctl
    # here we run PREP
    set fp [open prep.inp w]
    if {[file exists $prep(rootname).DAT]} { \
	puts $fp 1
    }
    puts $fp T
    puts $fp "$prep(dets), $prep(detl)"
    puts $fp 9
    close $fp
    #forknewterm "Run Prep" "$refgui(rietveld) $prep(rootname) < prep.inp" 
    #proc forknewterm {title command "background 0" "scrollbar 1" "wait 1"} 
    catch {exec $refgui(rietveld) $prep(rootname) < prep.inp >& prep.out}
    set fp [open prep.out r]
    set text [read $fp]
    close $fp
    ShowBigMessage .out "Prep output" $text [list OK "show $prep(rootname).PRP"]
    global makenew
    if {$makenew(result) != 1} {
	set fp [open $prep(rootname).PRP r]
	set tmp [read $fp]
	close $fp
	# get rid of first control character
	set text {}
	append text { } [string range $tmp 1 end]
	# fix up rest
	regsub -all "\n0" $text "\n\n " text
	regsub -all "\n1" $text \
		"\n---------------- (new page) -------------------------------------------\n " text
	
	ShowBigMessage .out "Prep output ($prep(rootname).PRP)" $text 
    }
    buttonbar $top
}
