array set rule {
    1 {
	A72
	in(title)
    }

    2 {
	A4,A4,F8.6,I8,3F8.0,I8
	in(ID) ignore in(epsilon) in(CALC) in(PH) in(PK) in(PL) in(LIM)
    }

    3 {
	6I8,F8.5
	in(CENTER) in(EQUIV) in(TYPE) in(FORM) in(ATOM) in(ROT) in(LAMBDA)
    }

    4a {
	3f6.2,f6.4,3f6.2,f6.4,3f6.2,f6.4
	in(R11_$i) in(R12_$i) in(R13_$i) in(T1_$i) 
	in(R21_$i) in(R22_$i) in(R23_$i) in(T2_$i) 
	in(R31_$i) in(R32_$i) in(R33_$i) in(T3_$i) 
    }

    4b {
	9f6.2
	in(M11${i}_$j) in(M12${i}_$j) in(M13${i}_$j) 
	in(M21${i}_$j) in(M22${i}_$j) in(M23${i}_$j) 
	in(M31${i}_$j) in(M32${i}_$j) in(M33${i}_$j)
    }

    5 {
	6f8.4
	in(SCATLEN[incr i]) in(SCATLEN[incr i]) in(SCATLEN[incr i]) 
	in(SCATLEN[incr i]) in(SCATLEN[incr i]) in(SCATLEN[incr i])
    }

    6 {
	2F8.4
	in(sinthol_${i}_[incr j]) in(fmag_${i}_$j)
    }

    7 {
	8I8
	in(CYCLE) in(LOUT) in(IPONS) in(LMAT)
	in(LCORD) in(LCOORD) in(BK) in(IDET)
    }

    8 {
	2F10.4
	in(SCALE) in(Q)
    }

    9a {
	A4,4I3,8f8.5
	in(LABEL$i) in(NTYP$i) in(MTYP$i) in(MROT$i) in(NTF$i) 
	in(X$i) in(Y$i) in(Z$i) in(B$i) in(OCC$i) 
	in(XMAG$i) in(YMAG$i) in(ZMAG$i)
    }

    9b {
	6f8.5
	in(BETA11$i) in(BETA22$i) in(BETA33$i) 
	in(BETA12$i) in(BETA13$i) in(BETA23$i) 
    }

    10 {
	4f8.2
	in(U) in(V) in(W) in(Z)
    }

    11 {
	I8
	in(DIR)
    }

    12a {
	6F12.7
	in(A) in(B) in(C) in(D) in(E) in(F)
    }

    12b {
	3F8.4,3F8.3
	in(A) in(B) in(C) in(D) in(E) in(F)
    }

    13 {
	3F8.4
	in(G) in(P) in(EX)
    }

    14 {
	I4,6F12.6
	in(NPAR_$n) in(BG1_$n) in(BG2_$n) in(BG3_$n) 
	in(BG4_$n) in(BG5_$n)  in(BG6_$n)
    }

    15 {
	2I8
	in(SIZE) in(SHAPE)
    }

    16a {
	8f8.2
	refval(X$i) refval(Y$i) refval(Z$i) refval(B$i) refval(OCC$i) 
	refval(XMAG$i) refval(YMAG$i) refval(ZMAG$i)
    }

    16b {
	6f8.2
	refval(BETA11$i) refval(BETA22$i) refval(BETA33$i) 
	refval(BETA12$i) refval(BETA13$i) refval(BETA23$i) 
    }

    17 {
	2f8.2
	refval(SCALE) refval(Q)
    }

    18 {
	6f8.2
	refval(BG1_$n) refval(BG2_$n) refval(BG3_$n) 
	refval(BG4_$n) refval(BG5_$n)  refval(BG6_$n)
    }

    19 {
	4f8.2
	refval(U) refval(V) refval(W) refval(Z)
    }

    20 {
	6F8.2
	refval(A) refval(B) refval(C) refval(D) refval(E) refval(F)
    }

    21 {
	3F8.2
	refval(G) refval(P) refval(EX)
    }

    22 {
	2I8
	in(NLC) in(TLS)
    }

    23 {
	A8,3I2,F10.5
	in(SP_name$i) in(SP_type$i) in(SP_num$i) in(SP_parm$i) in(SP_value$i) 
    }

    24 {
	10F8.2
	refval(SP$i) refval(SP[incr i]) refval(SP[incr i]) refval(SP[incr i]) 
	refval(SP[incr i]) refval(SP[incr i]) refval(SP[incr i]) refval(SP[incr i]) 
	refval(SP[incr i]) refval(SP[incr i]) 
    }
    25 {
	2I3,2i3,f8.4,2i3,f8.4,2i3,f8.4,2i3,f8.4,2i3,f8.4
	in(LC_atom$i) in(LC_parm$i) 
	in(L_atom${i}_[incr j]) in(L_parm${i}_$j) in(L_value${i}_$j) 
	in(L_atom${i}_[incr j]) in(L_parm${i}_$j) in(L_value${i}_$j) 
	in(L_atom${i}_[incr j]) in(L_parm${i}_$j) in(L_value${i}_$j) 
	in(L_atom${i}_[incr j]) in(L_parm${i}_$j) in(L_value${i}_$j) 
	in(L_atom${i}_[incr j]) in(L_parm${i}_$j) in(L_value${i}_$j) 
    }
}

# test an argument if it is a valid number; reform the number to fit
proc validreal {val length decimal} {
    upvar $val value
    # FORTRAN type assumption: blank is 0
    if {$value == ""} {set value 0.0}
    if [catch {expr $value}] {return 0}
    if [catch {
	set tmp [format "%#${length}.${decimal}f" $value]
	while {[string length $tmp] > $length} {
	    set tmp [format "%${length}.${decimal}E" $value]
	    incr decimal -1
	}
	set value $tmp
    }] {return 0}
    return 1
}

# test an argument if it is a valid integer; reform the number into
# an integer, if appropriate -- be sure to pass the name of the variable not the value
proc validint {val length} {
    upvar $val value
    # FORTRAN type assumption: blank is 0
    if {$value == ""} {set value 0}
    if [catch {
	set tmp [expr round($value)]
	if {$tmp != $value} {return 0}
	set value [format "%${length}d" $tmp]
    }] {return 0}
    return 1
}

proc readin {input varlist globals} {
    eval global $globals
    set fmt [lindex $varlist 0]
    set vars [lrange $varlist 1 end]
    set line {}
    set newfmt {}
    foreach f [string toupper [split $fmt ,] ] {
	if [regexp {([0-9]+)([IFA][0-9.]+)} $f junk nrep code] {
	    while {$nrep > 0} {
		lappend newfmt $code
		incr nrep -1
	    }
	} else {
	    lappend newfmt $f
	}
    }
    set pos 0
    foreach f $newfmt v $vars {
	if [regexp {A([0-9]+)} $f junk len] {
	    if {$v != "ignore"} {
		set $v [string range $input $pos [expr $pos+$len-1]]
	    }
	    incr pos $len
	} elseif [regexp {I([0-9]+)} $f junk len] {
	    set res [string range $input $pos [expr $pos+$len-1]]
	    if {[string trim $res] == ""} {set res 0}
	    set $v $res
	    incr pos $len
	} elseif [regexp {F([0-9]+)\.([0-9]+)} $f junk len dec] {
	    set res [string range $input $pos [expr $pos+$len-1]]
	    if {[string trim $res] == ""} {set res 0.}
	    set $v $res
	    incr pos $len
	}
    }
}

proc writeline {varlist globals} {
    eval global $globals
    set fmt [lindex $varlist 0]
    set vars [lrange $varlist 1 end]
    set newfmt {}
    foreach f [string toupper [split $fmt ,] ] {
	if [regexp {([0-9]+)([IFA][0-9.]+)} $f junk nrep code] {
	    while {$nrep > 0} {
		lappend newfmt $code
		incr nrep -1
	    }
	} else {
	    lappend newfmt $f
	}
    }
    set line {}
    foreach f $newfmt v $vars {
	if {$v == ""} break
	if [regexp {A([0-9]+)} $f junk len] {
	    set len1 [expr $len -1]
	    if {$v == "ignore"} {
		set val ""
	    } else {
		set val [set $v]
	    }
	    append line [ \
		    format %-${len}s [string range $val 0 $len1] 
	    ]
	} elseif [regexp {I([0-9]+)} $f junk len] {
	    validint $v $len
	    append line [set $v]
	} elseif [regexp {F([0-9]+)\.([0-9]+)} $f junk len dec] {
	    validreal $v $len $dec
	    append line [set $v]
	}
    }
    return $line
}

proc validateline {varlist globals} {
    global in rule
    eval global $globals
    set fmt [lindex $varlist 0]
    set vars [lrange $varlist 1 end]
    set line {}
    set newfmt {}
    foreach f [string toupper [split $fmt ,] ] {
	if [regexp {([0-9]+)([IFA][0-9.]+)} $f junk nrep code] {
	    while {$nrep > 0} {
		lappend newfmt $code
		incr nrep -1
	    }
	} else {
	    lappend newfmt $f
	}
    }
    set errmsg {}
    foreach f $newfmt v $vars {
	if [regexp {I([0-9]+)} $f junk len] {
	    if ![validint $v $len] {
		lappend errmsg \
			"Value of \"[set $v]\" is invalid for variable $v"
	    }
	} elseif [regexp {F([0-9]+)\.([0-9]+)} $f junk len dec] {
	    if ![validreal $v $len $dec] {
		lappend errmsg \
			"Value of \"[set $v]\" is invalid for variable $v"
	    }
	}
    }
    return $errmsg
}

proc ReadRefineFile {filename} {
    global in ref

    set inp {}
    set prm {}
    if {[file exists $filename.COM]} {
	set ans [tk_dialog .msg "Edit .COM?" \
		"File $filename.COM exists. Edit this file or Overwrite previous changes?" \
		"" 1 Edit Overwrite]
	if {$ans == 0} {
	    set inp [open $filename.COM r]
	    set mtime [file mtime $filename.COM]
	}
    }
    if {$inp == ""} {
	if {[file exists $filename.OLD]} {
	    set inp [open $filename.OLD r]
	    set mtime [file mtime $filename.OLD]
	    if {[file exists $filename.PRM]} {
		set ans [tk_dialog .msg "Read .PRM?" \
		"File $filename.PRM exists. Load or Ignore the last refinement?" \
		"" 0 Load Ignore]
		if {$ans == 0} {
		    set prm [open $filename.PRM r]
		    set mtime [file mtime $filename.PRM]
		}
	    }
	} else {
	    # get information from .CTL file
	    if [file exists $filename.CTL] {
		set fp [open $filename.CTL r]
		gets $fp in(title)
		gets $fp line
		set in(DIR) -1
		foreach val $line \
			var {A B C D E F} {
		    set in($var) $val
		}
		gets $fp line; #wave 2tM
		gets $fp line
		# set LCORD from centering in prep
		if {[lindex $line 1] <= 3} {
		    set in(LCORD) [expr [lindex $line 1] +1]
		} elseif {[lindex $line 1] == 4} {
		    set in(LCORD) 6
		} elseif {[lindex $line 1] == 5} {
		    set in(LCORD) 5
		} else {
		    set in(LCORD) 7
		}
		set ref(LCORD) [lindex $ref(cellMenuOpts) $in(LCORD)]
		close $fp
	    } else {
		tk_dialog .msg "No .CTL!" \
			"Unable to initialize properly, there is no PREP .CTL file (This should not happen!)" \
		    "" 0 OK
		return
	    }
	    if [file exists $filename.DET] {
		set fp [open $filename.DET r]
		gets $fp line
		set ref(DET1) [lindex $line 1]
		set ref(DET2) [lindex $line 2]
		set in(IDET) [expr $ref(DET1)*100 + $ref(DET2)]
		close $fp
	    }
	    return
	}
    }

    readoldprm $inp $prm
    # now update with information from the .CTL and .DET files
    if {[file exists $filename.CTL]} {
	if {$mtime < [file mtime $filename.CTL]} {
	    set fp [open $filename.CTL r]
	    gets $fp in(title)
	    gets $fp line
	    set in(DIR) -1
	    foreach val $line \
		    var {A B C D E F} {
		set in($var) $val
	    }
	    close $fp
	}
    }
    if [file exists $filename.DET] {
	set fp [open $filename.DET r]
	gets $fp line
	set ref(DET1) [lindex $line 1]
	set ref(DET2) [lindex $line 2]
	set in(IDET) [expr $ref(DET1)*100 + $ref(DET2)]
	close $fp
    }
    return
}

#--------------------------------------------------------------
proc CopyFromRefineFile {filename} {
    global in rule ref

    set inp {}
    set prm {}
    if {[file exists $filename.COM]} {
	if {[file mtime $filename.COM] > [file mtime $filename.CTL]} {
	    set inp [open $filename.COM r]
	}
    }
    if {$inp == "" && [file exists $filename.OLD]} {
	if {[file mtime $filename.OLD] > [file mtime $filename.CTL]} {
	    set inp [open $filename.OLD r]
	    if {[file exists $filename.PRM]} {
		set prm [open $filename.PRM r]
	    }
	} else {
	    if {[file exists $filename.PRM]} {
		if {[file mtime $filename.PRM] > [file mtime $filename.CTL]} {
		    set inp [open $filename.OLD r]
		    set prm [open $filename.PRM r]
		}
	    }
	}
    }
    if {$inp == ""} {return 0}

    readoldprm $inp $prm

    return 1
}

proc readoldprm {inp prm} {
    global in ref rule refval

    #line 1-3
    foreach line {1 2 3} {
	gets $inp input
	readin $input $rule($line) in
    }

    #lines 4a & b (symmetry & rotation matrices)
    for {set i 1} {$i <= $in(EQUIV)} {incr i} {
	gets $inp input
	readin $input [subst $rule(4a)] in
	
	for {set j 1} {$j <= $in(ROT)} {incr j} {
	    gets $inp input
	    readin $input [subst $rule(4b)] in
	}
    }

    #line 5 scattering lengths
    set i 0
    gets $inp input
    readin $input [subst $rule(5)] in
    if {$in(TYPE) > 6} {
	gets $inp input
	readin $input [subst $rule(5)] in
    }
    
    # line 6 magnetic form factors -- not tested
    for {set i 1} {$i <= $in(FORM)} {incr i} {
	set j 0
	set in(sinthol_${i}_0) 0
	while {$in(sinthol_${i}_$j) > -100. && $j < 21} {
	    gets $inp input
	    readin $input [subst $rule(6)] in
	}
    }    
    
    #line 7
    gets $inp input
    readin $input $rule(7) in
    set ref(LCORD) [lindex $ref(cellMenuOpts) $in(LCORD)]
    foreach item {CENTER LMAT LOUT} {
	set in($item) [string trim $in($item)]
    }


    #line 8
    gets $inp input
    readin $input $rule(8) in

    for {set i 1} {$i <= $in(ATOM)} {incr i} {
	#line 9a
	gets $inp input
	readin $input [subst $rule(9a)] in

	#line 9b
	gets $inp input
	readin $input [subst $rule(9b)] in
    }

    #line 10
    gets $inp input
    readin $input $rule(10) in

    #line 11
    gets $inp input
    readin $input $rule(11) in

    #line 12
    gets $inp input
    if {$in(DIR) < 0} {
	readin $input $rule(12b) in
    } else {
	readin $input $rule(12a) in
    }

    #line 13
    gets $inp input
    readin $input $rule(13) in

    # line 14 background parameters
    set det1 [expr $in(IDET)/100]
    set det2 [expr $in(IDET) - 100*$det1]
    for {set n $det1} {$n <= $det2} {incr n} {
	gets $inp input
	readin $input [subst $rule(14)] in
    }

    #line 15 -- number of variables & peak shape function #
    gets $inp input
    readin $input $rule(15) in

    #line 16a & 16b -- atom code words
    for {set i 1} {$i <= $in(ATOM)} {incr i} {
	gets $inp input
	readin $input [subst $rule(16a)] refval
	gets $inp input
	readin $input [subst $rule(16b)] refval
    }

    #line 17 code words: scale overall & temp factor.
    gets $inp input
    readin $input $rule(17) refval

    # line 18 code words: background
    set det1 [expr $in(IDET)/100]
    set det2 [expr $in(IDET) - 100*$det1]
    for {set n $det1} {$n <= $det2} {incr n} {
	gets $inp input
	readin $input [subst $rule(18)] refval
    }

    #line 19-22 
    foreach line {19 20 21 22} {
	gets $inp input
	readin $input $rule($line) "refval in"
    }
    # line 23 special parameters -- not tested
    for {set i 1} {$i <= $in(TLS)} {incr i} {
	gets $inp input
	readin $input [subst $rule(23)] in
    }
    # line 24 special parameter code words -- not tested
    for {set i 1} {$i <= $in(TLS)} {incr i} {
	gets $inp input
	readin $input [subst $rule(24)] refval
    }

    # line 25 linear constraints
    if {$in(NLC) > 0} {
	set i 1
	set j 0
	gets $inp input
	readin $input [subst $rule(25)] in
	while {$in(LC_atom$i)+$in(LC_parm$i) > 0} {
	    incr i
	    set j 0
	    gets $inp input
	    readin $input [subst $rule(25)] in
	}
    }
    catch {close $input}

    if {$prm == ""} return

    # now read from the .PRM file, if desired

    #line 8
    gets $prm input
    readin $input $rule(8) in

    for {set i 1} {$i <= $in(ATOM)} {incr i} {
	#line 9a
	gets $prm input
	readin $input [subst $rule(9a)] in

	#line 9b
	gets $prm input
	readin $input [subst $rule(9b)] in
    }

    #line 10
    gets $prm input
    readin $input $rule(10) in

    #line 11
    gets $prm input
    readin $input $rule(11) in

    #line 12
    gets $prm input
    if {$in(DIR) < 0} {
	readin $input $rule(12b) in
    } else {
	readin $input $rule(12a) in
    }

    #line 13
    gets $prm input
    readin $input $rule(13) in

    # line 14 background parameters
    set det1 [expr $in(IDET)/100]
    set det2 [expr $in(IDET) - 100*$det1]
    for {set n $det1} {$n <= $det2} {incr n} {
	gets $prm input
	readin $input [subst $rule(14)] in
    }

    catch {close $prm}
}


proc validatefile { } {
    global in rule

    set error {}
    #line 1-3
    foreach line {1 2 3} {
	append error " [validateline $rule($line) in]"
    }
    
    #lines 4a & b (symmetry & rotation matrices)
    for {set i 1} {$i <= $in(EQUIV)} {incr i} {
	append error " [validateline [subst $rule(4a)] in]"
	
	for {set j 1} {$j <= $in(ROT)} {incr j} {
	    append error " [validateline [subst $rule(4b)] in]"
	}
    }

    #line 5 scattering lengths
    set i 0
    append error " [validateline [subst $rule(5)] in]"
    if {$in(TYPE) > 6} {
	append error " [validateline [subst $rule(5)] in]"
    }
    
    # line 6 -- not tested
    for {set i 1} {$i <= $in(FORM)} {incr i} {
	set j 1
	while {$in(sinthol_${i}_$j) > -100. && $j < 21} {
	    append error " [validateline [subst $rule(6)] in]"
	}
    }    
    
    #line 7
    append error " [validateline $rule(7) in]"
    
    #line 8
    append error " [validateline $rule(8) in]"
    
    #line 9a & b atom params
    for {set i 1} {$i <= $in(ATOM)} {incr i} {
	append error " [validateline [subst $rule(9a)] in]"
	append error " [validateline [subst $rule(9b)] in]"
    }
    
    #line 10-13
    foreach line {10 11 12 13} {
	append error " [validateline $rule($line) in]"
    }

    # line 14 background parameters
    set det1 [expr $in(IDET)/100]
    set det2 [expr $in(IDET) - 100*$det1]
    for {set n $det1} {$n <= $det2} {incr n} {
	append error " [validateline [subst $rule(14)] in]"
    }

    #line 15
    append error " [validateline $rule(15) in]"

    #line 16a & 16b -- atom code words
    for {set i 1} {$i <= $in(ATOM)} {incr i} {
	append error " [validateline [subst $rule(16a)] refval]"
	append error " [validateline [subst $rule(16b)] refval]"
    }

    #line 17 code words: scale overall & temp factor.
    append error " [validateline $rule(17) refval]"

    # line 18 code words: background
    set det1 [expr $in(IDET)/100]
    set det2 [expr $in(IDET) - 100*$det1]
    for {set n $det1} {$n <= $det2} {incr n} {
	append error " [validateline [subst $rule(18)] refval]"
    }

    #line 19-22 
    foreach line {19 20 21 22} {
	append error " [validateline $rule($line) "refval in"]"
    }

    # line 23 special parameters -- not tested
    for {set i 1} {$i <= $in(TLS)} {incr i} {
	append error " [validateline [subst $rule(23)] in]"
    }
    # line 24 special parameter code words -- not tested
    for {set i 1} {$i <= $in(TLS)} {incr i} {
	append error " [validateline [subst $rule(24)] refval]"
    }

    # line 25 linear constraints -- loop over all defined terms
    regsub -all "LC_atom" [array names in LC_atom*] "" numlist
    foreach i [lsort $numlist] {
	set j 0
	if {$in(LC_atom$i) + $in(LC_parm$i) > 0} {
	    append error " [validateline [subst $rule(25)] in]"
	}
    }
    
    if {[llength $error] > 0} {return $error}
}

proc WriteRefineFile {filename} {
    set filenew $filename.COM
    set new [open $filenew w]
 
    global in rule refval

    #line 1-3
    foreach line {1 2 3} {
	puts $new [writeline $rule($line) in]
    }
    
    #lines 4a & b (symmetry & rotation matrices)
    for {set i 1} {$i <= $in(EQUIV)} {incr i} {
	puts $new [writeline [subst $rule(4a)] in]
	
	for {set j 1} {$j <= $in(ROT)} {incr j} {
	    puts $new [writeline [subst $rule(4b)] in]
	}
    }

    #line 5 scattering lengths
    set i 0
    puts $new [writeline [subst $rule(5)] in]
    if {$in(TYPE) > 6} {
	puts $new [writeline [subst $rule(5)] in]
    }
    
    # line 6 magnetic form factors -- not tested
    for {set i 1} {$i <= $in(FORM)} {incr i} {
	set j 0
	while {$j < 21} {
	    puts $new [writeline [subst $rule(6)] in]
	    if {$in(sinthol_${i}_$j) <= -100.} break
	}
    }    
    
    #line 7
    puts $new [writeline $rule(7) in]

    #line 8
    puts $new [writeline $rule(8) in]

    #line 9a & b atom params
    for {set i 1} {$i <= $in(ATOM)} {incr i} {
	puts $new [writeline [subst $rule(9a)] in]
	puts $new [writeline [subst $rule(9b)] in]
    }

    #line 10
    puts $new [writeline $rule(10) in]

    #line 11
    puts $new [writeline $rule(11) in]

    #line 12
    if {$in(DIR) < 0} {
	puts $new [writeline $rule(12b) in]
    } else {
	puts $new [writeline $rule(12a) in]
    }


    #line 13
    puts $new [writeline $rule(13) in]

    # line 14 background parameters
    set det1 [expr $in(IDET)/100]
    set det2 [expr $in(IDET) - 100*$det1]
    for {set n $det1} {$n <= $det2} {incr n} {
	puts $new [writeline [subst $rule(14)] in]
    }

    #line 15
    puts $new [writeline $rule(15) in]

    #line 16a & b atom param code words
    for {set i 1} {$i <= $in(ATOM)} {incr i} {
	puts $new [writeline [subst $rule(16a)] refval]
	puts $new [writeline [subst $rule(16b)] refval]
    }

    #line 17 code words: scale overall & temp factor.
    puts $new [writeline $rule(17) refval]

    # line 18 code words: background
    set det1 [expr $in(IDET)/100]
    set det2 [expr $in(IDET) - 100*$det1]
    for {set n $det1} {$n <= $det2} {incr n} {
	puts $new [writeline [subst $rule(18)] refval]
    }

    # redefine in(NLC) by the count of the number of constraints
    set in(NLC) 0
    regsub -all "LC_atom" [array names in LC_atom*] "" numlist
    foreach i [lsort $numlist] {
	set j 0
	if {$in(LC_atom$i) + $in(LC_parm$i) > 0} {
	    incr in(NLC)
	}
    }
    #line 19-22 
    foreach line {19 20 21 22} {
	puts $new [writeline $rule($line) "refval in"]
    }


    # line 23 special parameters -- not tested
    for {set i 1} {$i <= $in(TLS)} {incr i} {	
	puts $new [writeline [subst $rule(23)] in]
    }
    # line 24 special parameter code words -- not tested
    for {set i 1} {$i <= $in(TLS)} {incr i} {
	puts $new [writeline [subst $rule(24)] refval]
    }

    # line 25 linear constraints -- loop over all defined terms
    if {$in(NLC) > 0} {
	regsub -all "LC_atom" [array names in LC_atom*] "" numlist
	foreach i [lsort $numlist] {
	    set j 0
	    if {$in(LC_atom$i) + $in(LC_parm$i) > 0} {
		puts $new [writeline [subst $rule(25)] in]
	    }
	}
	# blank line to terminate
	puts $new {}
    }

    catch {close $new}
}

proc init_refine {mono col} {
    global cellparm prep extinctlbl in ref refval
    switch [string toupper $mono-$col] {
	GE311-15 {
	    set in(U)  ?
	    set in(V)  ?
	    set in(W)  ?
	}
	GE311-7 {
	    set in(U)  ?
	    set in(V)  ?
	    set in(W)  ?
	}
	CU311-15 {
	    set in(U)  ?
	    set in(V)  ?
	    set in(W)  ?
	}
	CU311-7 {
	    set in(U)  ?
	    set in(V)  ?
	    set in(W)  ?
	}
	SI531-15 {
	    set in(U)  ?
	    set in(V)  ?
	    set in(W)  ?
	}
	SI531-7 {
	    set in(U)  ?
	    set in(V)  ?
	    set in(W)  ?
	}
    }
    foreach var {A B C D E F G P} {
	set refval($var) 0
    }
    foreach i {1 2 3 4 5 6 7 8 9 10 11 12} {
	set in(SCATLEN$i) {}
    }

    foreach var {SIZE SCALE Q U V W Z EX} {
	set refval($var) 0
    }
    # 
    set in(epsilon) 0.001
    set in(CALC) 0
    set in(PH)     ""
    set in(PK)     ""
    set in(PL)     ""
    set in(LIM)    ""
    set in(EQUIV) 0
    set in(TYPE) 0
    set in(FORM) 0
    set in(ATOM) 0
    set in(ROT) 0
    set in(CYCLE) 5
    set in(LOUT)  0
    set in(IPONS) 3
    set in(LMAT)  1
    set in(LCORD) 0
    set in(LCOORD) 1
    set in(BK)     0  
    set in(SCALE) 1.
    set in(Q)     0.0
    set in(Z)     0.0
    set in(G)  0.0  
    set in(P)  4.5
    set in(EX) 0.0
    set in(SHAPE) 0
    set in(TLS) 0
    set in(CENTER) 0
    set in(SIZE) 0
    for {set i 1} {$i < 33} {incr i} {
	if {$i == 1} {
	    set in(NPAR_$i) 6
	} elseif {$i < 7 || $i > 27} {
	    set in(NPAR_$i) 4
	} else {
	    set in(NPAR_$i) 2
	}
	set in(BG1_$i) 100.
	for {set j 2} {$j <= 6} {incr j} {
	    set in(BG${j}_$i) 0.0
	}
	foreach j {1 2 3 4 5 6} {
	    set refval(BG${j}_$i) 0.0
	}
    }
    set ref(atomlist) {}

    # get from .CTL file
    set in(IDET)   132
    set ref(DET1)  1
    set ref(DET2)  32
}
# initialize cell
# from ctl file
# ref(DET1),ref(DET2),in(IDET) in(Z)  
# in(DIR) in(A) in(B) in(C) in(D) in(E) in(F)

#readfile test/AL2O3001
#parray in
#setCodeWords
#puts [validatefile]
#writefile test/AL2O3001

proc debc {} {
    global in rule
    regsub -all "LC_atom" [array names in LC_atom*] "" numlist
    foreach i [lsort $numlist] {
	set j 0
	puts $i
#	if {$in(LC_atom$i) + $in(LC_parm$i) > 0} {
	    puts [writeline [subst $rule(25)] in]
#	}
    }
}
# procedures for atoms page and constraints links

set ref(parmlist) {
    x y z B occ M(x) M(y) M(z) Beta11 Beta22 Beta33 Beta12 Beta13 Beta23
}

proc initalizeatoms {} {
    global ref in NTF

    set ref(atomlist) {}
    for {set i 1} {$i <= $in(ATOM)} {incr i} {lappend ref(atomlist) $i}
#    set ref(atomnamelist) {}
    for {set i 1} {$i <= $in(ATOM)} {incr i} {
	if [catch {set in(LABEL$i)}] {set in(LABEL$i) $i}
#	lappend ref(atomnamelist) $in(LABEL$i)
    }

    trace vdelete NTF w NTFset
    # transfer the in(NTFx) values to NTF(x)
    foreach elem $ref(atomlist) {
	if [catch {set in(NTF$elem)}] {set in(NTF$elem) 0}
	if {$in(NTF$elem)} {
	    set NTF($elem) aniso
	} else {
	    set NTF($elem) iso
	}
    }
    trace variable NTF w NTFset

    # fix
#    foreach num $ref(atomlist) nam $ref(atomnamelist) {
#	set ref(label$num) $nam
#    }
}

proc addatom {} {
    global ref in NTF refval

    if {$in(TYPE) <= 0} {
	tk_dialog .err "No atom types" \
		"You must define nuclear scattering lengths before adding atoms" \
		"" 0 "OK"

	return
    }
    incr in(ATOM)
    set i $in(ATOM)
    lappend ref(atomlist) $i
    set in(LABEL$i) $i
    set in(OCC$i) 1.0
    set in(B$i) 1.5
#    lappend ref(atomnamelist) $in(LABEL$i)
    
    foreach v {X Y Z B OCC XMAG  YMAG ZMAG \
	    BETA11 BETA22 BETA33 BETA12 BETA13 BETA23} {
	set refval(${v}${i}) 0
    }
    
    trace vdelete NTF w NTFset
    # initialize the in(NTFx) & NTF(x) variables
    set elem $i
    set in(NTF$elem) 0
    set NTF($elem) iso
    trace variable NTF w NTFset
}


proc atomsbox {top} {
    global ref NTF firstrow in
    set firstrow {}
    set row 1
    set atomtypes {}
    for {set i 1} {$i <= $in(TYPE)} {incr i} {lappend atomtypes $i}
    set magtypes {0}
    for {set i 1} {$i <= $in(FORM)} {incr i} {lappend magtypes $i}
#    if {$magtypes == ""} {set magtypes 0}
    set mag_rot_num {0}
    for {set i 1} {$i <= $in(ROT)} {incr i} {lappend mag_rot_num $i}
#    if {$mag_rot_num == ""} {set mag_rot_num 0}

    foreach atom $ref(atomlist) {
	set col -1
	foreach l {atomtypes magtypes mag_rot_num} \
		v {NTYP MTYP MROT} {
	    if {$row==1} {lappend firstrow $top.${l}${atom}}
	    set menu [eval tk_optionMenu $top.${l}${atom} in(${v}${atom}) [set $l]]
	    grid $top.${l}${atom} -column [incr col] -row $row -rowspan 2 -sticky nsew
	    if {$v == "MTYP"} {
		foreach item [set $l] {
		    $menu entryconfigure $item -command "MAGset $atom"
		}
	    }
	}
	if {$row==1} {lappend firstrow $top.temptyp${atom}}
	tk_optionMenu $top.temptyp${atom} NTF($atom) iso aniso
	grid $top.temptyp${atom} -column [incr col] -row $row -rowspan 2 -sticky ewns
	set row1 [expr 1 + $row]
	foreach v {X Y Z B OCC XMAG  YMAG ZMAG \
		BETA11 BETA22 BETA33 BETA12 BETA13 BETA23} \
		n {1 2 3 4   5   6     7    8   \
		9      10     11     12     13     14} {
	    if {$row==1} {lappend firstrow $top.v${v}_${atom}}
	    grid [entry $top.v${v}_${atom} -width 10 \
		    -textvariable in(${v}${atom})] \
		    -column [incr col] -row $row -sticky ew
	    bind $top.v${v}_${atom} <Button-3> "genconstraint $atom $n"
	    checkbutton $top.c${v}_${atom} -variable vflag(${v}${atom})
	    label $top.l${v}_${atom} -text Constrained -fg red
	}
	grid rowconf $top [expr 2 + $row] -minsize 10    
	incr row 3
    }
}

# show the constrained parameters
proc atomsflag {top} {
    global ref in
    set consparmlist {}
    regsub -all LC_atom [array names in LC_atom*] {} constrlist
    foreach i $constrlist {
	# is the parameter defined?
	if {$in(LC_atom$i) > 0 && $in(LC_parm$i) > 0} {
	    # is there an independent variable?
	    set flag 0
	    foreach j {1 2 3 4 5} {
		if {$in(L_atom${i}_$j) > 0 && $in(L_parm${i}_$j) > 0 && \
			$in(L_atom${i}_$j) != 0} {
		    set flag 1
		    break
		}
		# is there a fixed constant?
		if {$in(L_atom${i}_$j) == 0 && $in(L_parm${i}_$j) == 0 && \
			$in(L_value${i}_$j) != 0} {
		    set flag 1
		    break
		}
	    }
	    if {$flag} {
		set atom [string trim $in(LC_atom${i})]
		set parm [string trim $in(LC_parm${i})]
		lappend consparmlist ${atom}_${parm}
	    }
	}
    }
    set row 1
    foreach atom $ref(atomlist) {
	set col 3
	set row1 [expr 1 + $row]
	foreach v {X Y Z B OCC XMAG  YMAG ZMAG \
		BETA11 BETA22 BETA33 BETA12 BETA13 BETA23} \
		n {1 2 3 4   5   6     7    8   \
		9      10     11     12     13     14} {
	    if {[lsearch $consparmlist ${atom}_$n] == -1} {
		catch {grid forget $top.l${v}_${atom}}
		grid $top.c${v}_${atom} -column [incr col] -row $row1
	    } else {
		catch {grid forget $top.c${v}_${atom}}
		grid $top.l${v}_${atom} -column [incr col] -row $row1
	    }
	}
	incr row 3
    }
}

# set the variable flags for atom parameters based on the refval array
proc setatomsvflags {} {
    global ref in vflag refval
    foreach atom $ref(atomlist) {
	foreach v {X Y Z B OCC XMAG  YMAG ZMAG \
		BETA11 BETA22 BETA33 BETA12 BETA13 BETA23} \
		n {1 2 3 4   5   6     7    8   \
		9      10     11     12     13     14} {
	    set vflag(${v}${atom}) 0
	    catch {
		if {$refval(${v}${atom}) != 0} {set vflag(${v}${atom}) 1}
	    }
	}
    }
}

proc atomslbl {top} {
    set col -1
    foreach lbl {NTYP MTYP MROT NTF x y z Biso Occ M(x) M(y) M(z)}  {
	grid [label $top.l$col -text $lbl] -column [incr col] -row 0
    }
    foreach lbl {b11 b22 b33 b12 b13 b23} {
	grid [label $top.l$col -text $lbl -font symbol] -column [incr col] -row 0
    }
}

proc atomslblbox {top} {
    global ref
    set row 0
    foreach atom $ref(atomlist) {
	grid [entry $top.ent$atom -width 4 -textvariable in(LABEL$atom)] -column 0 -row [incr row]
	grid rowconf $top [incr row] -minsize 10    
    }
}

proc resizelbls {top lblside lbltop} {
    global ref
    bind $top.f <Configure> {}
    # inhibit recursion
#    puts resizelbls
    if $ref(resize) return
#    puts resizelbls...
    set ref(resize) 1
    update idletasks
    set row -1
    foreach atom $ref(atomlist) {
	grid rowconfig $lblside.f [incr row 2]  -minsize \
		[winfo height $top.f.atomtypes${atom}]
    }
    global firstrow
    set col -1
    foreach item $firstrow {
	grid columnconfig $lbltop.f [incr col]  -minsize \
		[winfo width $item]
    }
    update idletasks
    $lbltop config -scrollregion [grid bbox $lbltop.f]
    $lblside config -scrollregion [grid bbox $top.f]
    $top config -scrollregion [grid bbox $top.f]
    $lblside config -width [lindex [grid bbox $lblside.f] 2]
    $lbltop  config -height [lindex [grid bbox $lbltop.f] 3]
    set ref(resize) 0
    bind $top.f <Configure> "resizelbls $top $lblside $lbltop"
}

proc NTFset {arr elem action} {
    global in NTF refval ref
    set cantop $ref(atomsbox)
    if {$NTF($elem) == "iso"} {
	set in(NTF$elem) 0
	foreach v {BETA11 BETA22 BETA33 BETA12 BETA13 BETA23} {
	    $cantop.c.f.v${v}_$elem config -state disabled -relief flat \
		    -fg [$cantop.c.f.v${v}_$elem cget -bg]
	    $cantop.c.f.c${v}_$elem config -state disabled
	    set refval(${v}${elem}) 0
	}
    } else {
	set in(NTF$elem) 1
	# convert Biso to Beta
	
	set beta [cvtBiso $in(B$elem) $in(DIR) \
		"$in(A) $in(B) $in(C) $in(D) $in(E) $in(F)"]
	foreach v {BETA11 BETA22 BETA33 BETA12 BETA13 BETA23} \
		val $beta {
	    set val [format %.5f $val]
	    if {$val == 0.0} {set val 0.0}
	    set in(${v}$elem) [format %.5f $val]
	    $cantop.c.f.v${v}_$elem config -state normal -relief sunken \
		    -fg black
	    $cantop.c.f.c${v}_$elem config -state normal 
	}
    }
}

proc cvtBiso {Biso IDIR CELL} {
    # convert Biso to BetaIJ
    set RAD .01745329
    if {$IDIR == 1} {
	foreach i {1 2 3} j {0 1 2} {
            set GI($i) [lindex $CELL $j]
	}   
	foreach i {6 5 4} j {3 4 5} {
            set GI($i) [expr [lindex $CELL $j]/2.]
	}
   } else {
	set G1 [expr [lindex $CELL 0]*[lindex $CELL 0]]
        set G2 [expr [lindex $CELL 1]*[lindex $CELL 1]]
        set G3 [expr [lindex $CELL 2]*[lindex $CELL 2]]
        set G6 [expr [lindex $CELL 1]*[lindex $CELL 2]* \
		cos([lindex $CELL 3]*$RAD)]
        set G5 [expr [lindex $CELL 0]*[lindex $CELL 2]* \
		cos([lindex $CELL 4]*$RAD)]
        set G4 [expr [lindex $CELL 0]*[lindex $CELL 1]* \
		cos([lindex $CELL 5]*$RAD)]
        set DELTA [expr $G1*($G2*$G3-$G6*$G6)-$G4*($G4*$G3-$G5*$G6)+$G5*($G6*$G4-$G2*$G5)]
	set GI(1) [expr ($G2*$G3-$G6*$G6)/$DELTA]
	set GI(2) [expr ($G1*$G3-$G5*$G5)/$DELTA]
        set GI(3) [expr ($G1*$G2-$G4*$G4)/$DELTA]
        set GI(4) [expr ($G5*$G6-$G4*$G3)/$DELTA]
        set GI(5) [expr ($G4*$G6-$G5*$G2)/$DELTA]
        set GI(6) [expr ($G4*$G5-$G1*$G6)/$DELTA]
    }
    set beta {}
    foreach i {1 2 3 4 5 6} {
	lappend beta [expr $GI($i)*$Biso/4.]
    }
    return $beta
}

proc MAGset {elem} {
    global in refval ref
    set cantop $ref(atomsbox)
    if {$in(MTYP$elem) == 0} {
	foreach v {XMAG  YMAG ZMAG} {
	    $cantop.c.f.v${v}_$elem config -state disabled -relief flat \
		    -fg [$cantop.c.f.v${v}_$elem cget -bg]
	    $cantop.c.f.c${v}_$elem config -state disabled
	    set refval(${v}${elem}) 0
	}
	$cantop.c.f.mag_rot_num$elem config -state disabled
    } else {
	foreach v {XMAG  YMAG ZMAG} {
	    $cantop.c.f.v${v}_$elem config -state normal -relief sunken \
		    -fg black
	    $cantop.c.f.c${v}_$elem config -state normal 
	}
	$cantop.c.f.mag_rot_num$elem config -state normal
    }
}

proc genconstraint {atom parm} {
    global cons in ref
    catch {toplevel .cons}
    catch {eval destroy [grid slaves .cons]}
    raise .cons
    wm title .cons "Edit Constraint"
    set num 0
    # initialize constraint page
    set ref(atomnamelist) {}
    for {set i 1} {$i <= $in(ATOM)} {incr i} {
	if [catch {set in(LABEL$i)}] {set in(LABEL$i) $i}
	lappend ref(atomnamelist) $in(LABEL$i)
    }
    set cons(mult_1) 0.0
    foreach par {2 3 4 5} {
	set cons(atom_$par) ""
	set cons(parm_$par) ""
	set cons(mult_$par) 0.0
    }
    # need to scan for new vs old constraint
    regsub -all LC_atom [array names in LC_atom*] {} constrlist
    foreach i $constrlist {
	if {$in(LC_atom$i) == $atom && $in(LC_parm$i) == $parm} {
	    # is there an independent variable?
	    set flag 0
	    foreach j {1 2 3 4 5} {
		if {$in(L_atom${i}_$j) > 0 && $in(L_parm${i}_$j) > 0 && \
			$in(L_atom${i}_$j) != 0} {
		    set flag 1
		    break
		}
		# is there a fixed constant?
		if {$in(L_atom${i}_$j) == 0 && $in(L_parm${i}_$j) == 0 && \
			$in(L_value${i}_$j) != 0} {
		    set flag 1
		    break
		}
	    }
	    if {$flag} {set num $i}
	    break
	}
    }
    if {$num != 0} {
	# existing constraint
	# get the constant term, if any
	set k 1
	foreach j {1 2 3 4 5} {
	    if {$in(L_atom${num}_$j) == 0 && $in(L_parm${num}_$j) == 0 && \
		    $in(L_value${num}_$j) != 0} {
		set cons(mult_1) $in(L_value${num}_$j)
	    } elseif {$in(L_atom${num}_$j) != 0 && \
		    $in(L_parm${num}_$j) != 0 && \
		    $in(L_value${num}_$j) != 0} {
		incr k
		set cons(atom_$k) [lindex "null $ref(atomnamelist)" $in(L_atom${num}_$j) ]
		set cons(parm_$k) [lindex "null $ref(parmlist)" $in(L_parm${num}_$j)]
		set cons(mult_$k) $in(L_value${num}_$j) 
	    }
	}
    }
    makeconstraint .cons 1 $atom $parm
    tkwait variable cons(done)
    # save or delete was issued
    set parm [lsearch $ref(parmlist) $cons(type)]
    incr parm
    set atom [lsearch $ref(atomnamelist) $cons(atom)]
    incr atom
    # is there already a constraint for this parameter?
    set num [lindex [lsort -integer $constrlist] end]
    if {$num == ""} {set num 0}
    incr num
    set new 1
    foreach i $constrlist {
	if {$in(LC_atom$i) == $atom && $in(LC_parm$i) == $parm} {
	    set num $i
	    set new 0
	}
    }
    if $cons(done) {
	if {!$new} {
	    set in(LC_atom$num) 0
	    set in(LC_parm$num) 0
	}
    } else {
	set in(LC_atom$num) $atom 
	set in(LC_parm$num) $parm
	foreach j {1 2 3 4 5} {
	    set in(L_atom${num}_$j) 0
	    set in(L_parm${num}_$j) 0
	    set in(L_value${num}_$j) 0
	}
	set j 1
	if {$cons(mult_1) != 0} {
	    set in(L_atom${num}_1) 0
	    set in(L_parm${num}_1) 0
	    set in(L_value${num}_1) $cons(mult_1)
	    incr j
	}
	foreach k {2 3 4 5} {
	    set parm [lsearch $ref(parmlist) $cons(parm_$k)]
	    incr parm
	    set atom [lsearch $ref(atomnamelist) $cons(atom_$k)]
	    incr atom
	    if {$parm != 0 && $atom != 0 && $cons(mult_$k)!= 0} {
		set in(L_atom${num}_$j) $atom
		set in(L_parm${num}_$j) $parm
		set in(L_value${num}_$j) $cons(mult_$k)
		incr j
	    }
	}
    }
    destroy .cons
    atomsflag $ref(atomsbox).c.f
}

proc makeconstraint {top num "atomnum 0" "parmnum 0"} {
    global ref cons

    set rownum 2
    eval tk_optionMenu $top.1 cons(atom) $ref(atomnamelist)
    grid $top.1 -row $rownum -column 0
    eval tk_optionMenu $top.2 cons(type) $ref(parmlist)
    grid $top.2 -row $rownum -column 1
    if {$atomnum == 0} {
	set cons(atom) ""
	set cons(type) ""
	set cons(mult_1) 0.0
	foreach par {2 3 4 5} {
	    set cons(atom_$par) ""
	    set cons(parm_$par) ""
	    set cons(mult_$par) 0.0
	}
     } else {
	set cons(atom) [lindex $ref(atomnamelist) [expr $atomnum-1]]
	set cons(type) [lindex $ref(parmlist) [expr $parmnum-1]]
    }
    set col 2
    set par 1

    grid [label $top.p1 -text =] -column 2 -row $rownum
    grid [entry $top.3_$par -width 8 \
	    -textvariable cons(mult_$par)] \
	    -row $rownum -column 3

    foreach par {2 3 4 5} {
	set col 4
	grid [label $top.pa$par -text +] -column $col -row $rownum
	grid [entry $top.3_$par -width 8 \
		-textvariable cons(mult_$par)] \
		-row $rownum -column [incr col]
	grid [label $top.pb$par -text x] -column [incr col] -row $rownum
	eval tk_optionMenu $top.1_$par cons(atom_$par) $ref(atomnamelist) 
	grid $top.1_$par -row $rownum -column [incr col]
	eval tk_optionMenu $top.2_$par cons(parm_$par) $ref(parmlist)
	grid $top.2_$par -row $rownum -column [incr col]
	incr rownum 
    }
    grid columnconfig $top 2 -min 20
    grid [label $top.l1 -text "Dependent Variable"] -row 0 -column 0 \
	    -columnspan 2
    grid [label $top.l2 -text "Independent Variables"] -row 0 -column 3 \
	    -columnspan 15
    grid [label $top.l3 -text "Atom"]       -row 1 -column 0
    grid [label $top.l4 -text parameter]    -row 1 -column 1
    grid [label $top.1l -text "Constant"]   -row 1 -column 3
    grid [label $top.l7 -text "Multiplier"] -row 1 -column 5
    grid [label $top.l5 -text "Atom"]       -row 1 -column 7
    grid [label $top.l6 -text parameter]    -row 1 -column 8
    grid [frame $top.but -bd 4 -relief ridge] \
	    -row 4 -column 0 -rowspan 3 -columnspan 2 -sticky news
    pack [button $top.but.done -text Save -command "set cons(done) 0" \
	    ] -side left
    pack [button $top.but.del -text Delete -command "set cons(done) 1" \
	   ] -side left
}

proc scroll2 {boxlist args} {
    foreach box $boxlist {
	eval $box $args
    }
}

proc makeatomspage {cantop} {
    global ref
    wm title $cantop "Edit atoms"
    if {$cantop == ""} {set canpar .} else {set canpar $cantop}
    catch {eval destroy [grid slaves $canpar]}
    raise $cantop 
    bind $cantop <Control-KeyPress-c> "destroy $cantop"
    set ref(atomsbox) $cantop
    grid [frame $cantop.fr] \
	    -column 0 -columnspan 3 -row 0 -sticky ew
    grid columnconfig $cantop.fr 0 -weight 1
    grid [label $cantop.fr.l \
	    -text "Edit atomic parameters (right mouse for constraint)"] \
	    -column 0 -row 0 -sticky w
    grid [button $cantop.fr.b -text "Add Atom" \
	    -command "catch \toplevel $cantop\}; addatom; makeatomspage $cantop" \
	    ] -column 1 -row 0 -sticky e

    grid [canvas $cantop.ctop \
	    -width 500 -height 20] -sticky news -row 1 -column 1 
    grid [canvas $cantop.cside \
	    -width 40 -height 330] -sticky news -row 2 -column 0
    grid [canvas $cantop.c \
	    -scrollregion {0 0 5000 500} -width 500 -height 350] \
	    -sticky  news -row 2 -column 1
    grid [label $cantop.clbl -text Atom\nlabel] -column 0 -row 1
    grid [scrollbar $cantop.yscroll -orient vertical] \
	    -sticky ns -row 2 -column 2
    grid [scrollbar $cantop.xscroll -orient horizontal] \
	    -sticky ew -row 3 -column 1
    grid [button $cantop.quit -text "Close" -command "destroy $cantop"] \
	    -column 0 -row 4 -sticky w
    $cantop.c config \
	    -yscrollcommand "$cantop.yscroll set" \
	    -xscrollcommand "$cantop.xscroll set"
    $cantop.yscroll config -command \
	    "scroll2 \{ $cantop.c $cantop.cside \} yview"
    $cantop.xscroll config -command \
	    "scroll2 \{ $cantop.c $cantop.ctop \} xview"
    grid columnconfigure $canpar 1 -weight 1
    grid rowconfigure $canpar 2 -weight 1

    # create a frame to hold the atoms 
    frame $cantop.c.f
    $cantop.c create window 0 0 -anchor nw -window $cantop.c.f
    atomsbox $cantop.c.f
    #create a frame to hold the labels above the atoms and one dummy atom

    frame $cantop.ctop.f
    $cantop.ctop create window 0 0 -anchor nw -window $cantop.ctop.f
    atomslbl $cantop.ctop.f
    atomsflag $cantop.c.f
    frame $cantop.cside.f
    $cantop.cside create window 0 0 -anchor nw -window $cantop.cside.f
    atomslblbox $cantop.cside.f
    # set the temperature factor and Magnetic flags in the atoms box initially
    foreach elem $ref(atomlist) {
	#NTFset NTF $elem w
	global in NTF refval ref
	if {$NTF($elem) == "iso"} {
	    set in(NTF$elem) 0
	    foreach v {BETA11 BETA22 BETA33 BETA12 BETA13 BETA23} {
		$cantop.c.f.v${v}_$elem config -state disabled -relief flat \
			-fg [$cantop.c.f.v${v}_$elem cget -bg]
		$cantop.c.f.c${v}_$elem config -state disabled
		set refval(${v}${elem}) 0
	    }
	} else {
	    set in(NTF$elem) 1
	    foreach v {BETA11 BETA22 BETA33 BETA12 BETA13 BETA23} {
		$cantop.c.f.v${v}_$elem config -state normal -relief sunken \
			-fg black
		$cantop.c.f.c${v}_$elem config -state normal 
	    }
	}
	MAGset $elem
    }
    # resize the scroll window to match the actual
    set ref(resize) 0
    resizelbls $cantop.c $cantop.cside $cantop.ctop
}

proc makebpage {cantop} {
    global ref in
    wm title $cantop "Edit Scattering Length"
    if {$cantop == ""} {set canpar .} else {set canpar $cantop}
    catch {eval destroy [grid slaves $canpar]}
    raise $cantop 
    bind $cantop <Control-KeyPress-c> "destroy $cantop"
    grid [button $cantop.quit -text "Close" -command "destroy $cantop"] \
	    -column 1 -row 3 -sticky w
    grid [frame $cantop.fr] \
	    -column 1 -columnspan 2 -row 0 -sticky ew
    grid columnconfig $cantop.fr 0 -weight 1
    grid [label $cantop.fr.l \
	    -text "Edit Neutron Scattering Lengths (femtometers)"] \
	    -column 0 -row 0 -sticky w
    grid [button $cantop.fr.b -text "Add Length" \
	    -command "catch \{toplevel $cantop\}; incr in(TYPE); makebpage $cantop" \
	    ] -column 1 -row 0 -sticky e

    grid [canvas $cantop.c \
	    -scrollregion {0 0 5000 500} -width 500 -height 350] \
	    -sticky  news -row 1 -column 1
    grid [scrollbar $cantop.yscroll -orient vertical] \
	    -sticky ns -row 1 -column 2
    grid [scrollbar $cantop.xscroll -orient horizontal] \
	    -sticky ew -row 2 -column 1
    $cantop.c config \
	    -yscrollcommand "$cantop.yscroll set" \
	    -xscrollcommand "$cantop.xscroll set"
    $cantop.yscroll config -command \
	    "$cantop.c yview"
    $cantop.xscroll config -command \
	    "$cantop.c xview"
    grid columnconfigure $canpar 1 -weight 1
    grid rowconfigure $canpar 1 -weight 1

    # create a frame to hold the terms
    frame $cantop.c.f
    $cantop.c create window 0 0 -anchor nw -window $cantop.c.f

    set row 1
    set col 0
    for {set i 1} {$i <= $in(TYPE)} {incr i} {
        grid [label $cantop.c.f.l$i -text $i] -column $col -row $row
	incr col
	if {$col == 6} {set col 0; incr row 2}
    }
    set row 2
    set col 0
    for {set i 1} {$i <= $in(TYPE)} {incr i} {
        grid [entry $cantop.c.f.e$i -textvariable in(SCATLEN$i) -width 8] \
		-column $col -row $row
	incr col
	if {$col == 6} {set col 0; incr row 2}
    }

    # resize the scroll window to match the actual
    update idletasks
    $cantop.c config -scrollregion [grid bbox $cantop.c.f]
    update idletasks
}

proc makebkgpage {cantop} {
    global ref in
    wm title $cantop "Edit Background Functions"
    if {$cantop == ""} {set canpar .} else {set canpar $cantop}
    catch {eval destroy [grid slaves $canpar]}
    raise $cantop 
    bind $cantop <Control-KeyPress-c> "destroy $cantop"
    grid [button $cantop.quit -text "Close" -command "destroy $cantop"] \
	    -column 1 -row 3 -sticky w

    grid [canvas $cantop.ctop \
	    -width 500 -height 20] -sticky news -row 0 -column 1 
    grid [canvas $cantop.c \
	    -scrollregion {0 0 5000 500} -width 500 -height 350] \
	    -sticky  news -row 1 -column 1
    grid [scrollbar $cantop.yscroll -orient vertical] \
	    -sticky ns -row 1 -column 2
    grid [scrollbar $cantop.xscroll -orient horizontal] \
	    -sticky ew -row 2 -column 1
    $cantop.c config \
	    -yscrollcommand "$cantop.yscroll set" \
	    -xscrollcommand "$cantop.xscroll set"
    $cantop.yscroll config -command \
	    "$cantop.c yview"
#    $cantop.xscroll config -command \
#	    "$cantop.c xview"
    $cantop.xscroll config -command \
	    "scroll2 \{ $cantop.c $cantop.ctop \} xview"
    grid columnconfigure $canpar 1 -weight 1
    grid rowconfigure $canpar 1 -weight 1

    frame $cantop.ctop.f
    $cantop.ctop create window 0 0 -anchor nw -window $cantop.ctop.f
    grid [label $cantop.ctop.f.l1 -text Bank] -column 0 -row 0
    grid [label $cantop.ctop.f.l2 -text Refine] -column 1 -row 0
    grid [label $cantop.ctop.f.l3 -text "        Background terms"] -column 2 -row 0

    # create a frame to hold the terms
    frame $cantop.c.f
    $cantop.c create window 0 0 -anchor nw -window $cantop.c.f

    set row 0

    # don't let terms get out of range
    if {$ref(DET1) < 1 } {set ref(DET1) 1}
    if {$ref(DET2) > 32} {set ref(DET2) 32}

    for {set i $ref(DET1)} {$i <= $ref(DET2)} {incr i} {
	set col -1
        grid [label $cantop.c.f.la$i -text $i] -column [incr col] -row $row
        grid [checkbutton $cantop.c.f.b$i -variable vflag(BKG$i) \
		-command testAllBkg] -column [incr col] -row $row
        grid [button $cantop.c.f.a$i -text "Add" \
		-command "addBkgTerms $i 1; makebkgpage $cantop"] \
		-column [incr col] -row $row
        grid [button $cantop.c.f.r$i -text "Remove" \
		-command "addBkgTerms $i -1; makebkgpage $cantop"] \
		-column [incr col] -row $row
	for {set j 1} {$j <= $in(NPAR_$i)} {incr j} {
	    grid [entry $cantop.c.f.e${j}_$i \
		    -width 12 -textvariable in(BG${j}_$i)] \
		-column [incr col] -row $row
	}
	incr row
    }
    grid columnconfigure $cantop.c.f     0  -minsize 50 -pad 0
    grid columnconfigure $cantop.ctop.f  0  -minsize 50 -pad 0
    grid columnconfigure $cantop.c.f     1  -minsize 40 -pad 0
    grid columnconfigure $cantop.ctop.f  1  -minsize 40 -pad 0
#    grid columnconfigure $cantop.c.f  1  -pad 20
    # resize the scroll window to match the actual
    update idletasks
    $cantop.c config -scrollregion [grid bbox $cantop.c.f]
    $cantop.ctop config -scrollregion [grid bbox $cantop.c.f]
    $cantop.ctop config -height [lindex [grid bbox $cantop.ctop.f] 3]
    update idletasks
}

proc addBkgTerms {bank add} {
    global in
    if [catch {set in(NPAR_$bank)}] {set in(NPAR_$bank) 2} 
    if {$add == 1} {
	incr in(NPAR_$bank) 2
    } elseif {$add == -1} {
	incr in(NPAR_$bank) -2
    }
    # allowed values are 2,4,6
    if {$in(NPAR_$bank) < 2} {set in(NPAR_$bank) 2} 
    if {$in(NPAR_$bank) > 6} {set in(NPAR_$bank) 6} 
    if [catch {set in(BG1_$bank)}] {set in(BG1_$bank) 50.0} 
    for {set j 2} {$j <= $in(NPAR_$bank)} {incr j} {
	if [catch {set in(BG${j}_$bank)}] {set in(BG${j}_$bank) 0.0}
    }
}

proc setAllBkg {val} {
    global ref vflag
    for {set i $ref(DET1)} {$i <= $ref(DET2)} {incr i} {
	set vflag(BKG$i) $val
    }
}

proc testAllBkg {} {
    global ref vflag box
    set all 1
    set none 1
    for {set i $ref(DET1)} {$i <= $ref(DET2)} {incr i} {
	if {$vflag(BKG$i)} {
	    set none 0
	} else {
	    set all 0
	}
    }
    $box(BkgRefFrame).a config -relief raised
    $box(BkgRefFrame).b config -relief raised
    if {$all} {
	$box(BkgRefFrame).a config -relief sunken
    }
    if {$none} {
	$box(BkgRefFrame).b config -relief sunken
    }
}

proc setcellflag {args} {
    global ref vflag
    set vflag(cell) [lsearch $ref(cellreflbl) $ref(cell)]
}

# set the code words from the ref array
proc setCodeWords {} {
    global refval vflag in ref
    set parnum 0

    # construct a list of constrained parameters (consparmlist)
    set consparmlist {}
    regsub -all LC_atom [array names in LC_atom*] {} constrlist
    foreach i $constrlist {
	# is the parameter defined?
	if {$in(LC_atom$i) > 0 && $in(LC_parm$i) > 0} {
	    # is there an independent variable?
	    set flag 0
	    foreach j {1 2 3 4 5} {
		if {$in(L_atom${i}_$j) > 0 && $in(L_parm${i}_$j) > 0 && \
			$in(L_atom${i}_$j) != 0} {
		    set flag 1
		    break
		}
		# is there a fixed constant?
		if {$in(L_atom${i}_$j) == 0 && $in(L_parm${i}_$j) == 0 && \
			$in(L_value${i}_$j) != 0} {
		    set flag 1
		    break
		}
	    }
	    if {$flag} {
		set atom [string trim $in(LC_atom${i})]
		set parm [string trim $in(LC_parm${i})]
		lappend consparmlist ${atom}_${parm}
	    }
	}
    }

    # ----------
    # Code words
    # ----------

    # Scale
    if {$vflag(SCALE)} {
	set refval(SCALE) "[incr parnum]1.0"
    } else {
	set refval(SCALE) {0.}
    }

    # atoms - n x y z B betaij
    for {set atom 1} {$atom <= $in(ATOM)} {incr atom} {
	foreach v {OCC X Y Z B BETA11 BETA22 BETA33 BETA12 BETA13 BETA23} \
		n {5   1 2 3 4   9      10     11     12     13     14} {
	    if {$vflag(${v}${atom}) && \
		    [lsearch $consparmlist ${atom}_$n] == -1} {
		set refval(${v}${atom}) "[incr parnum]1.0"
	    } else {
		set refval(${v}${atom}) {0.}
	    }
	}
    }

    # atoms - Mx My Mz
    for {set atom 1} {$atom <= $in(ATOM)} {incr atom} {
	foreach v {XMAG YMAG ZMAG} \
		n {  6    7    8 } {
	    if {$vflag(${v}${atom}) && \
		    [lsearch $consparmlist ${atom}_$n] == -1} {
		set refval(${v}${atom}) "[incr parnum]1.0"
	    } else {
		set refval(${v}${atom}) {0.}
	    }
	    
	}
    }
    # background
    for {set i $ref(DET1)} {$i <= $ref(DET2)} {incr i} {
	# zero out old values
	foreach j {1 2 3 4 5 6} {set refval(BG${j}_${i}) "0."}
	if {$vflag(BKG$i)} {
	    for {set j 1} {$j <= $in(NPAR_$i)} {incr j} {
		set refval(BG${j}_${i}) "[incr parnum]1.0"
	    }
	}
    }
    # cell
    foreach v {A B C D E F} {set refval($v) "0."}
    if {$vflag(cell) == 1} {
	# 1 triclinic A,B,C,D,E,F
	foreach v {A B C D E F} {
	    set refval($v) "[incr parnum]1.0"
	}
    } elseif {$vflag(cell) == 2} {
	# 2 MONOCLINIC B unique A,B,C,E
	foreach v {A B C E} {
	    set refval($v) "[incr parnum]1.0"
	}
    } elseif {$vflag(cell) == 3} {
	# 3 MONOCLINIC C unique A,B,C,F
	foreach v {A B C F} {
	    set refval($v) "[incr parnum]1.0"
	}
    } elseif {$vflag(cell) == 4} {
	# 4 ORTHORHOMBIC A,B,C
	foreach v {A B C} {
	    set refval($v) "[incr parnum]1.0"
	}
    } elseif {$vflag(cell) == 5} {
	# 5 TETRAGONAL A=B, C
	foreach v {A C} {
	    set refval($v) "[incr parnum]1.0"
	}
	set refval(B) $refval(A)
    } elseif {$vflag(cell) == 6} {
	# 6 HEXAGONAL A=B=F, C
	foreach v {A C} {
	    set refval($v) "[incr parnum]1.0"
	}
	set refval(B) $refval(A)
	set refval(F) $refval(A)
    } elseif {$vflag(cell) == 7} {
	# 7 cubic A=B=C 
	set refval(A) "[incr parnum]1.0"
	set refval(B) $refval(A)
	set refval(C) $refval(A)
    } elseif {$vflag(cell) == 8} {
	# 8 rhombic a=b=c, d=e=f
	set refval(A) "[incr parnum]1.0"
	set refval(B) $refval(A)
	set refval(C) $refval(A)
	set refval(D) "[incr parnum]1.0"
	set refval(E) $refval(D)
	set refval(F) $refval(D)
    }
    
    # remaining overall parameters Zero, profile, Pref Or, Asym, Extin
    foreach v {Z U V W Q G P EX} {
	if {$vflag($v)} {
	    set refval($v) "[incr parnum]1.0"
	} else {
	    set refval($v) {0.}
	}
    }
    set in(SIZE) $parnum
}

proc makemagpage {cantop} {
    global ref in blt_version
    wm title $cantop "Edit Magnetic Form Factor"
    if {$cantop == ""} {set canpar .} else {set canpar $cantop}
    catch {eval destroy [grid slaves $canpar]}
    raise $cantop 
    bind $cantop <Control-KeyPress-c> "destroy $cantop"
    grid [button $cantop.quit -text "Close" -command "destroy $cantop"] \
	    -column 1 -row 3 -sticky w

    grid [frame $cantop.fr] \
	    -column 0 -columnspan 3 -row 0 -sticky ew
    grid columnconfig $cantop.fr 0 -weight 1
    grid [label $cantop.fr.l \
	    -text "Edit Magnetic Scattering Form Factor"] \
	    -column 0 -row 0 -sticky w
    grid [button $cantop.fr.b -text "Add magnetic curve" \
	    -command "catch \{toplevel $cantop\};  incr in(FORM); makemagpage $cantop" \
	    ] -column 1 -row 0 -sticky e

    grid [canvas $cantop.c \
	    -scrollregion {0 0 5000 500} -width 500 -height 350] \
	    -sticky  news -row 1 -column 1
    grid [scrollbar $cantop.yscroll -orient vertical] \
	    -sticky ns -row 1 -column 2
    grid [scrollbar $cantop.xscroll -orient horizontal] \
	    -sticky ew -row 2 -column 1
    $cantop.c config \
	    -yscrollcommand "$cantop.yscroll set" \
	    -xscrollcommand "$cantop.xscroll set"
    $cantop.yscroll config -command \
	    "$cantop.c yview"
    $cantop.xscroll config -command \
	    "$cantop.c xview"
    grid columnconfigure $canpar 1 -weight 1
    grid rowconfigure $canpar 1 -weight 1

    # create a frame to hold the terms
    frame $cantop.c.f
    $cantop.c create window 0 0 -anchor nw -window $cantop.c.f

    set row 0
    for {set i 1} {$i <= $in(FORM)} {incr i} {
	grid [label $cantop.c.f.l$i \
	    -text "Form Factor #$i" -anchor w] \
	    -column 0 -row $row -columnspan 2 -sticky w
	grid [frame $cantop.c.f.f$i] -column 2 \
		-row $row -columnspan 5 -sticky e
	pack [button $cantop.c.f.f$i.c -command "evalpoly $cantop $i" \
	    -text "Set #$i from polynomial"] -side left
	pack [button $cantop.c.f.f$i.a -command "plotmag $cantop $i" \
	    -text "Plot #$i"] -side right
	pack [button $cantop.c.f.f$i.b -command "plotmag $cantop $i Q" \
	    -text "Plot #$i in Q"] -side right
	incr row
	set col 0
	for {set j 1} {$j <= 21} {incr j} {
	    # check for new variables and initialize them
	    if [catch {set in(sinthol_${i}_$j)}] {set in(sinthol_${i}_$j) -100.}
	    if [catch {set in(fmag_${i}_$j)}] {set in(fmag_${i}_$j) 1.}	    
	    grid [label $cantop.c.f.l${j}_$i  -text $j \
		    ] -column $col -row $row
	    grid [entry $cantop.c.f.s${j}_$i  -width 8 \
		    -textvariable in(sinthol_${i}_$j)] \
		    -column $col -row [expr 1+$row]
	    grid [entry $cantop.c.f.f${j}_$i  -width 8 \
		    -textvariable in(fmag_${i}_$j)] \
		    -column $col -row [expr 2+$row]
	    incr col
	    if {$col == 7} {
		set col 0
		incr row 3
		grid rowconfig .edit.c.f $row -minsize 5
		incr row
	    }
	}
	incr row
	set col 0
	for {set j 1} {$j <= 21} {incr j} {
	    incr col
	    if {$col == 7} {set col 0; incr row 3}
	}
	incr row
    }

    # resize the scroll window to match the actual
    update idletasks
    $cantop.c config -scrollregion [grid bbox $cantop.c.f]
    update idletasks
}

proc plotmag {cantop i "units sthl"} {
    global in

    set symblist {none circle square diamond plus cross splus scross triangle}

    catch {destroy $cantop.p}
    catch {grid [graph $cantop.g] -row 0 -rowspan 3 -column 3}
    set x {0.}
    set y {1.}
    set j 0
    while {$in(sinthol_${i}_[incr j]) > -100. && $j < 21} {
	if {$units == "Q"} {
	    lappend x [expr 4 * 3.14159 * [string trim $in(sinthol_${i}_$j)]]
	} else {
	    lappend x [string trim $in(sinthol_${i}_$j)]
	}
	lappend y [string trim $in(fmag_${i}_$j)]
    }
    $cantop.g configure -title "Form Factor Plot"
    catch {$cantop.g element create $i}
    $cantop.g element config $i -xdata $x -ydata $y -symbol [lindex $symblist $i]
    if {$units == "Q"} {
	$cantop.g xaxis config -title Q
    } else {
	$cantop.g xaxis config -title "sin(theta) / lambda"
    }
}

# evaluate the International Tables polynomial for magnetic scattering
proc FFAC {X A1 A2 B1 B2 C1 C2 D} {
    set X [expr -$X*$X]
    return [expr ($A1*exp($A2*$X)+$B1*exp($B2*$X)+$C1*exp($C2*$X)+$D)/($A1+$B1+$C1+$D)]
}

proc evalpoly {cantop i} {
    global in

    catch {destroy $cantop.g}
    catch {destroy $cantop.p}
    catch {grid [frame $cantop.p] -row 0 -rowspan 3 -column 3}
    grid [label $cantop.p.l -text "Enter polynomial for Form Factor $i"] \
	    -column 1 -row 0 -columnspan 4
    set col 0
    set row 1
    set num 0
    foreach lbl {A a B b C c D} {
	incr num
	grid [label $cantop.p.l$num -text $lbl] -column [incr col] -row $row
	grid [entry $cantop.p.e$num -width 10 -textvariable ref(poly_$lbl)] \
		-column [incr col] -row $row
	if {$col % 4 == 0} {set col 0; incr row}
    }
    grid [button $cantop.p.c -text "Set" \
	    -command "setpoly $i; catch \"destroy $cantop.p\" " \
	    ] -row 5 -column 0 -columnspan 3
    grid [button $cantop.p.q -text "Quit" -command "catch \"destroy $cantop.p\" "] \
	    -row 5 -column 3 -columnspan 3
}

proc setpoly {i} {
    global in ref
    for {set j 1} {$j <= 21} {incr j} {
	set in(sinthol_${i}_$j) [set x [expr $j*0.03]]
	set in(fmag_${i}_$j) [format %.5f [FFAC $x \
		$ref(poly_A) $ref(poly_a) $ref(poly_B) $ref(poly_b) \
		$ref(poly_C) $ref(poly_c) $ref(poly_D)]]
    }
}

proc makesympage {cantop} {
    global ref in symlist

    wm title $cantop "Edit Symmetry"
    if {$cantop == ""} {set canpar .} else {set canpar $cantop}
    catch {eval destroy [grid slaves $canpar]}
    raise $cantop 
    bind $cantop <Control-KeyPress-c> "destroy $cantop"
    grid [button $cantop.quit -text "Close" -command "destroy $cantop"] \
	    -column 1 -row 3 -sticky w
    grid [frame $cantop.fr] -row 0 -column 1 -columnspan 2 -sticky ew
    grid columnconfig $cantop.fr 0 -weight 1
    grid [label $cantop.fr.sl -text "Set symmetry from space group:"] \
	    -column 0 -row 0 -sticky w
    set sgmenu [tk_optionMenu  $cantop.fr.spg ref(spacegroup) x]
    grid $cantop.fr.spg -column 1 -row 0 -sticky w
    grid [button $cantop.fr.b1 -text "Add magnetic\nrotation matrix" \
	    -command "catch \{toplevel $cantop\}; incr in(ROT); makesympage $cantop" \
	    ] -column 2 -row 0 -rowspan 2 -sticky e
    grid [button $cantop.fr.b2 -text "Add equivalent\nposition" \
	    -command "catch \{toplevel $cantop\}; incr in(EQUIV); makesympage $cantop" \
	    ] -column 3 -row 0 -rowspan 2 -sticky e

    grid [checkbutton $cantop.fr.center -variable in(CENTER) \
	    -text "Centrosymmetric" -onvalue 2 -offvalue 1] -column 0 -row 1 -sticky ew
    set ref(spacegroup) {(choose)}
    $sgmenu delete 0 end
    foreach lbl {triclinic monoclinic orthorhombic tetragonal \
	    hexagonal-axes rhombohedral-axes cubic} {
	$sgmenu add cascade -label $lbl -menu $sgmenu.$lbl
	set menu [menu $sgmenu.$lbl -tearoff 0]
	set i 0
	foreach sym $symlist($lbl) {
	    incr i
	    if {$i>20} {
		set i 0
		$menu add cascade -label more... -menu $menu.more
		set menu [menu $menu.more -tearoff 0]
	    }
	    $menu add command -label $sym -command "SetSym [list $sym] $cantop"
	}
    }
    
    grid [canvas $cantop.c \
	    -scrollregion {0 0 5000 500} -width 500 -height 350] \
	    -sticky  news -row 1 -column 1
    grid [scrollbar $cantop.yscroll -orient vertical] \
	    -sticky ns -row 1 -column 2
    grid [scrollbar $cantop.xscroll -orient horizontal] \
	    -sticky ew -row 2 -column 1
    $cantop.c config \
	    -yscrollcommand "$cantop.yscroll set" \
	    -xscrollcommand "$cantop.xscroll set"
    $cantop.yscroll config -command \
	    "$cantop.c yview"
    $cantop.xscroll config -command \
	    "$cantop.c xview"
    grid columnconfigure $canpar 1 -weight 1
    grid rowconfigure $canpar 1 -weight 1

    # create a frame to hold the terms
    frame $cantop.c.f
    $cantop.c create window 0 0 -anchor nw -window $cantop.c.f

    set row 1
    incr row
    set num 0
    grid [label $cantop.c.f.l0 \
	    -text "Symmetry operation #0" -anchor w] \
	    -column 0 -row $row -columnspan 5 -sticky w
    foreach j {1 2 3} l {"x =" "y =" "z = "} {
	incr row
	set col 0
	grid [label $cantop.c.f.la0_$j -text $l ] \
		-column [incr col] -row $row
	grid [label $cantop.c.f.t0_$num -text 0.0 ] \
			-column [incr col] -row $row
	grid [label $cantop.c.f.lb0_$j -text "+" ] \
			-column [incr col] -row $row
	foreach v {1 2 3} ll {"x  +" "y  +" "z"} {
	    incr num
	    if {$v == $j} {set txt 1.0} else {set txt 0.0}
	    grid [label $cantop.c.f.e0_$num -text $txt] \
			-column [incr col] -row $row
	    grid [label $cantop.c.f.lc0_$num -text $ll ] \
		    -column [incr col] -row $row
	}
    }
    for {set k 1} {$k <= $in(ROT)} {incr k} {
	incr row
	grid [label $cantop.c.f.r0_$k \
		-text "Magnetic Rotation #0-$k" -anchor w] \
		-column 3 -row $row -columnspan 4 -sticky w
	foreach j {1 2 3} l {"x =" "y =" "z = "} {
	    incr row
	    set col 2
	    grid [label $cantop.c.f.ld0_$num -text $l ] \
		    -column [incr col] -row $row
	    foreach v {1 2 3} ll {"x  +" "y  +" "z"} {
		incr num
		if {$v == $j} {set txt 1.0} else {set txt 0.0}
		grid [label $cantop.c.f.f0_$num -text $txt] \
			-column [incr col] -row $row
		grid [label $cantop.c.f.le0_$num -text $ll ] \
			-column [incr col] -row $row
	    }
	}
    }
    for {set i 1} {$i <= $in(EQUIV)} {incr i} {
	# create a spacer
	incr row 
	grid [frame $cantop.c.f.space$row -bg black -width 0 -height 2] \
	    -column 0 -columnspan 10 -row $row -sticky ew 
	grid rowconfigure $cantop.c.f $row -pad 4
	incr row
	grid [label $cantop.c.f.l$i \
	    -text "Symmetry operation #$i" -anchor w] \
	    -column 0 -row $row -columnspan 5 -sticky w
	set num 0
	foreach j {1 2 3} l {"x =" "y =" "z = "} {
	    incr row
	    set col 0
	    grid [label $cantop.c.f.la${i}_$j -text $l ] \
			-column [incr col] -row $row
	    if [catch {set in(T${j}_$i)}] {set in(T${j}_$i) 0}
	    grid [entry $cantop.c.f.t${i}_$num -width 6 \
			-textvariable in(T${j}_$i)] \
			-column [incr col] -row $row
	    grid [label $cantop.c.f.lb${i}_$j -text "+" ] \
			-column [incr col] -row $row
	    foreach v "R${j}1_$i R${j}2_$i R${j}3_$i" \
		    ll {"x  +" "y  +" "z"} {
		incr num
		if [catch {set in($v)}] {set in($v) 0.}
		grid [entry $cantop.c.f.e${i}_$num -width 5 \
			-textvariable in($v)] \
			-column [incr col] -row $row
		grid [label $cantop.c.f.lc${i}_$num -text $ll ] \
			-column [incr col] -row $row
	    }
	}
	for {set k 1} {$k <= $in(ROT)} {incr k} {
	    incr row
	    grid [label $cantop.c.f.r${i}_$k \
		    -text "Magnetic Rotation #$i-$k" -anchor w] \
		    -column 3 -row $row -columnspan 4 -sticky w
	    foreach j {1 2 3} l {"x =" "y =" "z = "} {
		incr row
		set col 2
		grid [label $cantop.c.f.ld${i}_$num -text $l ] \
			-column [incr col] -row $row
		foreach v "M${j}1${i}_$k M${j}2${i}_$k M${j}3${i}_$k" \
			ll {"x  +" "y  +" "z"} {
		    incr num
		    if [catch {set in($v)}] {set in($v) 0.}
		    grid [entry $cantop.c.f.f${i}_$num -width 5 \
			    -textvariable in($v)] \
			    -column [incr col] -row $row
		    grid [label $cantop.c.f.le${i}_$num -text $ll ] \
			    -column [incr col] -row $row
		}
	    }
	}
    }

    # resize the scroll window to match the actual
    update idletasks
    $cantop.c config -scrollregion [grid bbox $cantop.c.f]
    update idletasks
}

# procedure to convert a reciprocal cell tensor ro direct cell constants
proc DirectCell {A B C D E F} {
    foreach var {A B C D E F} num {1 2 3 4 5 6} {
	set V($num) [set $var]
    }
    set i 0
    foreach ia {1 2 3} {
	incr i
	set id [expr $ia + 3]
	set ie [expr [set ib [expr 1 + ($ia % 3)]] + 3]
	set ig [expr [set ic [expr 1 + ($ib % 3)]] + 3]
	set FNUM [expr 4.*$V($ib)*$V($ic)-$V($id)*$V($id)]
        set DEN [expr 4.*$V($ia)*$V($ib)*$V($ic)-$V($ia)*$V($id)*$V($id)-$V($ib)*$V($ie)*$V($ie)-$V($ic)*$V($ig)*$V($ig)+$V($id)*$V($ie)*$V($ig)]
	set S($i) [expr sqrt ($FNUM/$DEN) ]
        set FNUM [expr $V($ie)*$V($ig)-2.*$V($ia)*$V($id)]
        set DEN [expr 16.*$V($ia)*$V($ia)*$V($ib)*$V($ic)+$V($ie)*$V($ie)*$V($ig)*$V($ig)-4.*($V($ia)*$V($ib)*$V($ie)*$V($ie)+$V($ic)*$V($ia)*$V($ig)*$V($ig))]
	set i3 [expr $i+3]
	set S($i3) [expr $FNUM*$FNUM/$DEN]
	if {$S($i3) == 0} {
	    set S($i3) 90.
	} elseif {$FNUM < 0} {
            set S($i3) [expr 180 - 90./acos(0) * atan(sqrt((1.-$S($i3))/$S($i3)))]
	} else {
            set S($i3) [expr 90./acos(0) * atan(sqrt((1.-$S($i3))/$S($i3)))]
	}
    }
    return "$S(1) $S(2) $S(3) $S(4) $S(5) $S(6)"
}

proc EditCell {cantop} {
    global in
    wm title $cantop "Edit Unit Cell Parameters"
    if {$cantop == ""} {set canpar .} else {set canpar $cantop}
    catch {eval destroy [grid slaves $canpar]}
    raise $cantop 
    bind $cantop <Control-KeyPress-c> "destroy $cantop"
    grid [button $cantop.quit -text "Close" -command "destroy $cantop"] \
	    -column 1 -row 3 -sticky w
    grid [label $cantop.t -text "Edit Unit Cell Parameters"] -col 1 -row 0 -sticky w
    # convert the cell, if needed
    if {$in(DIR) == 1} {
	#set cellstring [DirectCell $in(A) $in(B) $in(C) $in(D) $in(E) $in(F)]
	set i -1
	foreach val [DirectCell $in(A) $in(B) $in(C) $in(D) $in(E) $in(F)] \
		var {A B C D E F} digits {6 6 6 3 3 3} {
	    set in($var) [format %.${digits}f $val]
	}
	set in(DIR) -1
    }
    grid [canvas $cantop.c \
	    -scrollregion {0 0 5000 500} -width 500 -height 350] \
	    -sticky  news -row 1 -column 1
    grid [scrollbar $cantop.yscroll -orient vertical] \
	    -sticky ns -row 1 -column 2
    grid [scrollbar $cantop.xscroll -orient horizontal] \
	    -sticky ew -row 2 -column 1
    $cantop.c config \
	    -yscrollcommand "$cantop.yscroll set" \
	    -xscrollcommand "$cantop.xscroll set"
    $cantop.yscroll config -command \
	    "$cantop.c yview"
    $cantop.xscroll config -command \
	    "$cantop.c xview"
    grid columnconfigure $canpar 1 -weight 1
    grid rowconfigure $canpar 1 -weight 1

    # create a frame to hold the terms
    frame $cantop.c.f
    $cantop.c create window 0 0 -anchor nw -window $cantop.c.f

    set topbox $cantop.c.f
    set col 1
    set row 1
    foreach var {a b c} {
	grid [label $topbox.l$var -anchor e -text $var] \
		-column $col -row [incr row]
	grid [entry $topbox.e$var \
		-width 10 -relief sunken -bd 2 \
		-textvariable in([string toupper $var])] \
		-column [expr 1+$col] -row $row
    }
    set col 3
    set row 1
    foreach var {D E F} lbl {a b g} {
	grid [label $topbox.l$var -anchor e -text $lbl -font symbol] \
		-column $col -row [incr row]
	grid [entry $topbox.e$var \
		-width 10 -relief sunken -bd 2 -textvariable in($var)] \
		-column [expr 1+$col] -row $row
    }
    # resize the scroll window to match the actual
    update idletasks
    $cantop.c config -scrollregion [grid bbox $cantop.c.f]
    update idletasks
}

array set symlist {
    P1            1    
    P-1	      2    
    P2	      3    
    P21	      4    
    C2	      5    
    Pm	      6    
    Pc	      7    
    Cm	      8    
    Cc	      9    
    P2/m	      10   
    P21/m	      11   
    C2/m	      12   
    P2/c	      13   
    P21/c	      14   
    C2/c	      15   
    P222	      16   
    P2221	      17   
    P21212	      18   
    P212121	      19   
    C2221	      20   
    C222	      21   
    F222	      22   
    I222	      23   
    I212121	      24   
    Pmm2	      25   
    Pmc21	      26   
    Pcc2	      27   
    Pma2	      28   
    Pca21	      29   
    Pnc2	      30   
    Pmn21	      31   
    Pba2	      32   
    Pna21	      33   
    Pnn2	      34   
    Cmm2	      35   
    Cmc21	      36   
    Ccc2	      37   
    Amm2	      38   
    Abm2	      39   
    Ama2	      40   
    Aba2	      41   
    Fmm2	      42   
    Fdd2	      43   
    Imm2	      44   
    Iba2	      45   
    Ima2	      46   
    Pmmm	      47   
    Pnnn	      -48  
    "Pnnn (org 1)"    48
    Pccm	      49   
    Pban	      -50  
    "Pban (org 1)"    50
    Pmma	      51   
    Pnna	      52   
    Pmna	      53   
    Pcca	      54   
    Pbam	      55   
    Pccn	      56   
    Pbcm	      57   
    Pnnm	      58   
    Pmmn	      -59  
    "Pmmn (org 1)"    59
    Pbcn	      60   
    Pbca	      61   
    Pnma	      62   
    Cmcm	      63   
    Cmca	      64   
    Cmmm	      65   
    Cccm	      66   
    Cmma	      67   
    Ccca	      -68  
    "Ccca (org 1)"    68
    Fmmm	      69   
    Fddd	      -70  
    "Fddd (org 1)"    70
    Immm	      71   
    Ibam	      72   
    Ibca	      73   
    Imma	      74   
    P4	      75   
    P41	      76   
    P42	      77   
    P43	      78   
    I4	      79   
    I41	      80   
    P-4	      81   
    I-4	      82   
    P4/m	      83   
    P42/m	      84   
    P4/n	      -85  
    "P4/n (org 1)"    85
    P42/n	      -86  
    P42/n	      86   
    I4/m	      87   
    I41/a	      -88  
    "I41/a (org 1)"   88
    P422	      89   
    P4212	      90   
    P4122	      91   
    P41212	      92   
    P4222	      93   
    P42212	      94   
    P4322	      95   
    P43212	      96   
    I422	      97   
    I4122	      98   
    P4mm	      99   
    P4bm	      100  
    P42cm	      101  
    P42nm	      102  
    P4cc	      103  
    P4nc	      104  
    P42mc	      105  
    P42bc	      106  
    I4mm	      107  
    I4cm	      108  
    I41md	      109  
    I41cd	      110  
    P-42m	      111  
    P-42c	      112  
    P-421m	      113  
    P-421c	      114  
    P-4m2	      115  
    P-4c2	      116  
    P-4b2	      117  
    P-4n2	      118  
    I-4m2	      119  
    I-4c2	      120  
    I-42m	      121  
    I-42d	      122  
    P4/mmm	      123  
    P4/mcc	      124  
    P4/nbm	      -125 
    "P4/nbm (org 1)"  125
    P4/nnc	      -126 
    "P4/nnc (org 1)"  126
    P4/mbm	      127  
    P4/mnc	      128  
    P4/nmm	      -129 
    "P4/nmm (org 1)"  129
    P4/ncc	      -130 
    "P4/ncc (org 1)"  130
    P42/mmc	      131  
    P42/mcm	      132  
    P42/nbc	      -133 
    "P42/nbc (org 1)" 133
    P42/nnm	      -134 
    "P42/nnm (org 1)" 134
    P42/mbc	      135  
    P42/mnm	      136  
    P42/nmc	      -137 
    "P42/nmc (org 1)" 137
    P42/ncm	      -138 
    "P42/ncm (org 1)" 138
    I4/mmm	      139  
    I4/mcm	      140  
    I41/amd	      -141 
    "I41/amd (org 1)" 141
    I41/acd	      -142 
    "I41/acd (org 1)" 142
    P3	      143  
    P31	      144  
    P32	      145  
    R3	      -146 
    P-3	      147  
    R-3	      -148 
    P312	      149  
    P321	      150  
    P3112	      151  
    P3121	      152  
    P3212	      153  
    P3221	      154  
    R32	      -155 
    P3m1	      156  
    P31m	      157  
    P3c1	      158  
    P31c	      159  
    R3m	      -160 
    R3c	      -161 
    P-31m	      162  
    P-31c	      163  
    P-3m1	      164  
    P-3c1	      165  
    R-3m	      -166 
    R-3c	      -167 
    P6	      168  
    P61	      169  
    P65	      170  
    P62	      171  
    P64	      172  
    P63	      173  
    P-6	      174  
    P6/m	      175  
    P63/m	      176  
    P622	      177  
    P6122	      178  
    P6522	      179  
    P6222	      180  
    P6422	      181  
    P6322	      182  
    P6mm	      183  
    P6cc	      184  
    P63cm	      185  
    P63mc	      186  
    P-6m2	      187  
    P-6c2	      188  
    P-62m	      189  
    P-62c	      190  
    P6/mmm	      191  
    P6/mcc	      192  
    P63/mcm	      193  
    P63/mmc	      194  
    "R3 (rhom)"       146
    "R-3 (rhom)"      148
    "R32 (rhom)"      155
    "R3m (rhom)"      160
    "R3c (rhom)"      161
    "R-3m (rhom)"     166
    "R-3c (rhom)"     167
    P23	      195  
    F23	      196  
    I23	      197  
    P213	      198  
    I213	      199  
    Pm-3	      200  
    Pn-3	      -201 
    "Pn-3 (org 1)"    201
    Fm-3	      202  
    Fd-3	      -203 
    "Fd-3 (org 1)" 203
    Im-3	      204  
    Pa-3	      205  
    Ia-3	      206  
    P432	      207  
    P4232	      208  
    F432	      209  
    F4132	      210  
    I432	      211  
    P4332	      212  
    P4132	      213  
    I4132	      214  
    P-43m	      215  
    F-43m	      216  
    I-43m	      217  
    P-43n	      218  
    F-43c	      219  
    I-43d	      220  
    Pm-3m	      221  
    Pn-3n	      -222 
    Pm-3n	      223  
    Pn-3m	      -224 
    Fm-3m	      225  
    Fm-3c	      226  
    Fd-3m	      -227 
    Fd-3c	      -228 
    Im-3m	      229  
    Ia-3d	      230  
}

set symlist(triclinic) {
    P1
    P-1
}
set symlist(monoclinic) {
    P2
    P21
    C2
    Pm
    Pc
    Cm
    Cc
    P2/m
    P21/m
    C2/m
    P2/c
    P21/c
    C2/c
}
set symlist(orthorhombic) {
    P222
    P2221
    P21212
    P212121
    C2221
    C222
    F222
    I222
    I212121
    Pmm2
    Pmc21
    Pcc2
    Pma2
    Pca21
    Pnc2
    Pmn21
    Pba2
    Pna21
    Pnn2
    Cmm2
    Cmc21
    Ccc2
    Amm2
    Abm2
    Ama2
    Aba2
    Fmm2
    Fdd2
    Imm2
    Iba2
    Ima2
    Pmmm
    Pnnn
    "Pnnn (org 1)"
    Pccm
    Pban
    "Pban (org 1)"
    Pmma
    Pnna
    Pmna
    Pcca
    Pbam
    Pccn
    Pbcm
    Pnnm
    Pmmn
    "Pmmn (org 1)"
    Pbcn
    Pbca
    Pnma
    Cmcm
    Cmca
    Cmmm
    Cccm
    Cmma
    Ccca
    "Ccca (org 1)"
    Fmmm
    Fddd
    "Fddd (org 1)"
    Immm
    Ibam
    Ibca
    Imma
}
set symlist(tetragonal) {
    P4
    P41
    P42
    P43
    I4
    I41
    P-4
    I-4
    P4/m
    P42/m
    P4/n
    "P4/n (org 1)"
    P42/n
    P42/n
    I4/m
    I41/a
    "I41/a (org 1)"
    P422
    P4212
    P4122
    P41212
    P4222
    P42212
    P4322
    P43212
    I422
    I4122
    P4mm
    P4bm
    P42cm
    P42nm
    P4cc
    P4nc
    P42mc
    P42bc
    I4mm
    I4cm
    I41md
    I41cd
    P-42m
    P-42c
    P-421m
    P-421c
    P-4m2
    P-4c2
    P-4b2
    P-4n2
    I-4m2
    I-4c2
    I-42m
    I-42d
    P4/mmm
    P4/mcc
    P4/nbm
    "P4/nbm (org 1)"
    P4/nnc
    "P4/nnc (org 1)"
    P4/mbm
    P4/mnc
    P4/nmm
    "P4/nmm (org 1)"
    P4/ncc
    "P4/ncc (org 1)"
    P42/mmc
    P42/mcm
    P42/nbc
    "P42/nbc (org 1)"
    P42/nnm
    "P42/nnm (org 1)"
    P42/mbc
    P42/mnm
    P42/nmc
    "P42/nmc (org 1)"
    P42/ncm
    "P42/ncm (org 1)"
    I4/mmm
    I4/mcm
    I41/amd
    "I41/amd (org 1)"
    I41/acd
    "I41/acd (org 1)"
}
set symlist(hexagonal-axes) {
    P3
    P31
    P32
    R3
    P-3
    R-3
    P312
    P321
    P3112
    P3121
    P3212
    P3221
    R32
    P3m1
    P31m
    P3c1
    P31c
    R3m
    R3c
    P-31m
    P-31c
    P-3m1
    P-3c1
    R-3m
    R-3c
    P6
    P61
    P65
    P62
    P64
    P63
    P-6
    P6/m
    P63/m
    P622
    P6122
    P6522
    P6222
    P6422
    P6322
    P6mm
    P6cc
    P63cm
    P63mc
    P-6m2
    P-6c2
    P-62m
    P-62c
    P6/mmm
    P6/mcc
    P63/mcm
    P63/mmc
}
set symlist(rhombohedral-axes) {
    "R3 (rhom)"
    "R-3 (rhom)"
    "R32 (rhom)"
    "R3m (rhom)"
    "R3c (rhom)"
    "R-3m (rhom)"
    "R-3c (rhom)"
}
set symlist(cubic) {
    P23
    F23
    I23
    P213
    I213
    Pm-3
    Pn-3
    "Pn-3 (org 1)"
    Fm-3
    Fd-3
    "Fd-3 (org 1)"
    Im-3
    Pa-3
    Ia-3
    P432
    P4232
    F432
    F4132
    I432
    P4332
    P4132
    I4132
    P-43m
    F-43m
    I-43m
    P-43n
    F-43c
    I-43d
    Pm-3m
    Pn-3n
    Pm-3n
    Pn-3m
    Fm-3m
    Fm-3c
    Fd-3m
    Fd-3c
    Im-3m
    Ia-3d
}


# get symmetry by spacegroup number
proc getsym {num} {
    global refgui in
    
    set in(CENTER) 0
    set in(EQUIV) 0
    set in(ROT) 0

    set fp [open [file join $refgui(scriptdir) bin symmetry.tbl] r]
    set nspg 0
    while {$nspg != $num} {
	if {[gets $fp line] == -1} {break} 
	set nspg [lindex $line 0]
    }
    if {$num == $nspg} {
	set in(CENTER) [lindex $line 1]
	set in(LCORD) [lindex $line 2]
	set in(EQUIV) [lindex $line 3]
	set j 4
	for {set i 1} {$i <= $in(EQUIV)} {incr i} {
	    foreach var {in(R11_$i) in(R12_$i) in(R13_$i) in(T1_$i) \
		    in(R21_$i) in(R22_$i) in(R23_$i) in(T2_$i) \
		    in(R31_$i) in(R32_$i) in(R33_$i) in(T3_$i)} {
		set str [lrange $line $j $j]
		incr j
		#puts "$var [subst $var] $str [expr 1.*$str]"
		set [subst $var] [expr 1.*$str]
	    }
	}
    }
    close $fp
}

proc SetSym {sym cantop} {
    global symlist ref 
    getsym $symlist($sym)
    makesympage $cantop
    set ref(spacegroup) $sym
}
# disable refine if cell is changed
#
#set box(top) {.test}
#toplevel .test
#set box(top) {}

set ref(cellreflbl) {"do not refine cell" \
	"refine triclinic cell" \
	"ref. monoclinic (b unique)" \
	"ref. monoclinic (c unique)" \
	"refine orthorhombic cell" \
	"refine tetragonal cell" \
	"refine hexagonal cell" \
	"refine cubic cell" \
	"refine rhombohedral cell"}

set ref(cellMenuOpts) "{no BONDAN} \
	{BONDAN Primitive} {BONDAN A-centered} {BONDAN B-centered} \
	{BONDAN C-centered} {BONDAN I-centered} {BONDAN F-centered} \
	{BONDAN R-centered}"

proc refinebox {top} {
    global box in ref
    set box(top) $top
    # clear out the old (for debuging)
    if {$box(top) == ""} {
	catch {eval destroy [grid slaves .]}
    } else {
	catch {eval destroy [grid slaves $box(top)]}
    }

    # make the box tops
    foreach v {00 01 11 02 03} {
	set box($v) [frame $box(top).b$v -relief groove -bd 4]
    }
    grid $box(00) -column 0 -row 0 -columnspan 2 -sticky w
    grid $box(01) -column 0 -row 1 -sticky w
    grid $box(11) -column 1 -row 1 -rowspan 2 -sticky nw
    grid $box(02) -column 0 -row 2  -sticky w
    grid $box(03) -column 0 -row 3 -columnspan 2  -sticky ew

    #---------------------- Box 1 -------------------------------------
    grid [label $box(00).ltitle -text Title] -row 1 -column 1
    grid [entry $box(00).etitle -textvariable in(title) -width 55] \
	    -row 1 -column 2 -columnspan 8

    #---------------------- Box 2 -------------------------------------
    set top $box(01)
    
    set row 1
    #-sticky ew
    grid [button $top.b2 -text "Edit Nuclear\nscattering lengths" \
	    -command {catch {toplevel .edit}; makebpage .edit} \
	    ] -row $row -column 1  -sticky ew
    grid [label  $top.e2 -textvariable in(TYPE)] -row $row -column 2
    grid [label  $top.l2 -text "lengths"] -row $row -column 3
#    grid [label  $top.l2 -text "Nuclear\nscattering\nlengths"] -row $row -column 1
#    grid [label  $top.e2 -textvariable in(TYPE)] -row $row -column 2
#    grid [button $top.b2a -text "Add" \
#	    -command {catch {toplevel .edit}; incr in(TYPE); makebpage .edit} \
#	    ] -row $row -column 3 
#    grid [button $top.b2b -text "Edit" \
#	    -command {catch {toplevel .edit}; makebpage .edit} \
#	    ] -row $row -column 4

    incr row
#    grid [label  $top.l7 -text "Background"] -row $row -column 1
#    grid [button $top.b7a -text "Edit" \
#	    -command {catch {toplevel .edit};  makebkgpage .edit} \
#	    ] -row $row -column 3 -columnspan 2
    grid [button $top.b7 -text "Edit Background" \
	    -command {catch {toplevel .edit};  makebkgpage .edit} \
	    ] -row $row -column 1 -sticky ew
    
    incr row
    grid [button $top.b3 -text "Edit magnetic\nscattering curves" \
	    -command {catch {toplevel .edit}; makemagpage .edit} \
	    ] -row $row -column 1  -sticky ew
    grid [label  $top.e3 -textvariable in(FORM)] -row $row -column 2
    grid [label  $top.l3 -text "curves"] -row $row -column 3
#    grid [button $top.b3a -text "Add" \
#	    -command {catch {toplevel .edit}; incr in(FORM); makemagpage .edit} \
#	    ] -row $row -column 3 
#    grid [label  $top.l3 -text "Magnetic\nscattering\ncurves"] -row $row -column 1
#    grid [label  $top.e3 -textvariable in(FORM)] -row $row -column 2
#    grid [button $top.b3a -text "Add" \
#	    -command {catch {toplevel .edit}; incr in(FORM); makemagpage .edit} \
#	    ] -row $row -column 3 
#    grid [button $top.b3b -text "Edit" \
#	    -command {catch {toplevel .edit}; makemagpage .edit} \
#	    ] -row $row -column 4
    
    incr row
    grid [button $top.b4 -text "Edit equivalent\npositions" \
	    -command {catch {toplevel .edit}; makesympage .edit} \
	    ] -row $row -column 1 -sticky ew
    grid [label  $top.e4 -textvariable in(EQUIV)] -row $row -column 2
    grid [label  $top.l4 -text "positions"] -row $row -column 3
#    grid [label  $top.l4 -text "Equivalent\npositions"] -row $row -column 1
#    grid [label  $top.e4 -textvariable in(EQUIV)] -row $row -column 2
#    grid [button $top.b4a -text "Add" \
#	    -command {catch {toplevel .edit}; incr in(EQUIV); makesympage .edit} \
#	    ] -row $row -column 3 
#    grid [button $top.b45b -text "Edit" \
#	    -command {catch {toplevel .edit}; makesympage .edit} \
#	    ] -row $row -column 4 -rowspan 2

    incr row
    grid [button $top.b5 -text "Edit magnetic\nrotation matrices" \
	    -command {catch {toplevel .edit}; makesympage .edit} \
	    ] -row $row -column 1 -sticky ew
    grid [label  $top.e5 -textvariable in(ROT)] -row $row -column 2
    grid [label  $top.l5 -text "matrices"] -row $row -column 3
#    grid [label  $top.l5 -text "Magnetic\nrotation\nmatrices"] -row $row -column 1
#    grid [label  $top.e5 -textvariable in(ROT)] -row $row -column 2
#    grid [button $top.b5a -text "Add" \
#	    -command {catch {toplevel .edit}; incr in(ROT); makesympage .edit} \
#	    ] -row $row -column 3 
    
    incr row 
    grid [button $top.b6 -text "Edit Atoms" \
	    -command {catch {toplevel .edit}; makeatomspage .edit}] \
	    -row $row -column 1 -sticky ew
    grid [label  $top.e6 -textvariable in(ATOM)] -row $row -column 2
    grid [label  $top.l6 -text "atoms"] -row $row -column 3
#    grid [label  $top.l6 -text "Atoms"] -row $row -column 1
#    grid [button $top.b6a -text "Add" \
#	    -command {catch {toplevel .edit}; addatom; makeatomspage .edit} \
#	    ] -row $row -column 3
#    grid [button $top.b6b -text "Edit" \
#	    -command {catch {toplevel .edit}; makeatomspage .edit} \
#	    ] -row $row -column 4

    incr row
    grid columnconfig  $top 2 -pad 25
    #---------------------- Box 3 -------------------------------------
    set top $box(02)
    grid [label  $top.lcalc -text "Intensity\ncomputation"] -row 3 -column 4
    set box(IntMenu) [tk_optionMenu $top.ecalc ref(x1) \
	    {only nuclear} {Halpern & Johnson} {uniaxial spins} {cubic spin sym}]
    grid $top.ecalc -row 3 -column 5 -columnspan 2
    foreach i {0 1 2 3} {
	$box(IntMenu) entryconfigure $i -command "set in(CALC) $i"
    }
    grid [label  $top.lpr -text "Print\noptions"] -row 4 -column 4
    grid [checkbutton $top.pr1 -text {profile} \
	    -variable in(LOUT)] -row 4 -column 5
    grid [checkbutton $top.pr2 -text "correlation\nmatrix" \
	    -variable in(LMAT)] -row 4 -column 6

    grid [label  $top.lpr1 -text "Output\noptions"] -row 5 -column 4
    set box(FileMenu) [tk_optionMenu $top.pr3 ref(x3) {no files} \
	    Fourier Intensities Fourier+Intensities ORTEP Fourier+ORTEP \
	    Intensities+ORTEP All]
    grid $top.pr3 -row 5 -column 5 -columnspan 2
    foreach i {0 1 2 3 4 5 6 7} {
	$box(FileMenu) entryconfigure $i -command "set in(IPONS) $i"
    }
    set box(CellMenu) [eval tk_optionMenu $top.pr4 ref(LCORD) $ref(cellMenuOpts)]
    grid $top.pr4 -row 6 -column 4 -columnspan 3 -sticky e
    foreach i {0 1 2 3 4 5 6 7} {
	$box(CellMenu) entryconfigure $i -command "set in(LCORD) $i"
    }

    #grid [label  $top.ldet -text "Use detectors"] -row 2 -column 4
    #grid [frame $top.det] -row 2 -column 5
    ##grid [entry  $top.det.1 -textvariable ref(DET1) -width 3] -row 1 -column 1
    #grid [label  $top.det.1 -textvariable ref(DET1)] -row 1 -column 1
    #grid [label  $top.det.l -text to] -row 1 -column 2
    ##grid [entry  $top.det.2 -textvariable ref(DET2) -width 3] -row 1 -column 3
    #grid [label  $top.det.2 -textvariable ref(DET2)] -row 1 -column 3

    #---------------------- Box 3 -------------------------------------
    set top $box(11)
    set col1 1
    set col2 [expr $col1 + 1]
    set col3 [expr $col1 + 2]
    set row 1
    grid [label  $top.l$row -text "wavelength"] -row $row -column $col1
    grid [entry  $top.e$row -textvariable in(LAMBDA) -width 8] \
	    -row $row -column $col2
    incr row
    
    foreach varnam {SCALE Q U V W Z EX G P} \
	    label {"Scale Factor" "Overall\nIso B" U V W "2Th Zero" Extinction "Preferred\nOrientation" Asymmetry} {
	grid [label  $top.l$row -text $label] -row $row -column $col1
	grid [entry  $top.e$row -textvariable in($varnam) -width 10] \
		-row $row -column $col2
	grid [checkbutton $top.c$row -variable vflag($varnam)] -row $row -column $col3
	incr row
    }
    grid [label  $top.l$row -text "Extra peak\nshape terms"] -row $row -column $col1
    grid [entry  $top.e$row -textvariable in(SHAPE) -width 10] \
	    -row $row -column $col2
    incr row
    grid [label  $top.lB -text Background] -row $row -column $col1
    grid [frame  $top.fB] \
	    -row $row -column $col2 -columnspan 2
    set box(BkgRefFrame) $top.fB
    pack [button $top.fB.a -text "Ref\nAll" \
	    -command "setAllBkg 1;testAllBkg"] -side left
    pack [button $top.fB.b -text "Ref\nNone" \
	    -command "setAllBkg 0;testAllBkg"] -side left
    incr row
    eval tk_optionMenu $top.rcell ref(cell) $ref(cellreflbl)

    grid $top.rcell -row $row -column $col1 -columnspan 3
    incr row
    grid [button $top.ecell -text "Edit Cell Parameters" \
	    -command {catch {toplevel .edit}; EditCell .edit} \
	    ] -row $row -column $col1 -columnspan 3
    incr row
    #---------------------- Box 3 -------------------------------------
    set top $box(03)
    grid [button $top.b -text "Run Refine" \
	    -command "RunRefine $box(top)"] -column 1 -row 1
    grid [button $top.q -text Quit \
	    -command "buttonbar $box(top)"] -column 2 -row 1
}

#---------------------- Initialization code -----------------------
# the following is probably not needed as ref(DET1) and  ref(DET2) do not change
proc setIDET {args} {
    global in ref
    set DET1 $ref(DET1)
    if {$ref(DET1) < 1} {set DET1 1}
    set DET2 $ref(DET2)
    if {$ref(DET2) > 32} {set DET2 32}
    catch {
	set in(IDET) [expr $DET1 * 100 + $DET2]
    }
    # set background terms as needed
    for {set i $DET1} {$i <= $DET2} {incr i} {
	addBkgTerms $i 0
    }
}

proc initgui {} {
    global in ref refval vflag box

    $box(IntMenu) invoke [string trim $in(CALC)]
    $box(FileMenu) invoke [string trim $in(IPONS)]
    trace variable ref(cell) w setcellflag

    # set the cell refinement flag
    if {$refval(A) == $refval(B) && $refval(A) == $refval(C) && \
	    $refval(A) != 0 && \
	    $refval(D) == 0 && $refval(E) == 0 && $refval(F) == 0 } {
	set ref(cell) [lindex $ref(cellreflbl) 7]
    } elseif {$refval(A) == $refval(B) && $refval(A) == $refval(C) && \
	    $refval(A) != 0 && \
	    $refval(D) == $refval(E) && $refval(E) == $refval(F)} {
	set ref(cell) [lindex $ref(cellreflbl) 8]
    } elseif {$refval(A) == $refval(B) && $refval(C) != 0 && \
	    $refval(A) != 0 && \
	    $refval(D) == 0 && $refval(E) == 0 && $refval(F) == 0 } {
	set ref(cell) [lindex $ref(cellreflbl) 5]
    } elseif {$refval(A) != 0 && $refval(B) != 0 && $refval(C) != 0 && \
	    $refval(D) == 0 && $refval(E) == 0 && $refval(F) == 0 } {
	set ref(cell) [lindex $ref(cellreflbl) 4]
    } elseif {$refval(A) == $refval(B) && $refval(A) == $refval(F) && \
	    $refval(A) != 0 && \
	    $refval(C) != 0 && $refval(D) == 0 && $refval(E) == 0 } {
	set ref(cell) [lindex $ref(cellreflbl) 6]
    } elseif {$refval(A) != 0 && $refval(B) != 0 && $refval(C) != 0 && \
	    $refval(D) == 0 && $refval(E) != 0 && $refval(F) == 0 } {
	set ref(cell) [lindex $ref(cellreflbl) 2]
    } elseif {$refval(A) != 0 && $refval(B) != 0 && $refval(C) != 0 && \
	    $refval(D) == 0 && $refval(E) == 0 && $refval(F) != 0 } {
	set ref(cell) [lindex $ref(cellreflbl) 3]
    } elseif {$refval(A) != 0 && $refval(B) != 0 && $refval(C) != 0 && \
	    $refval(D) != 0 && $refval(E) != 0 && $refval(F) != 0 } {
	set ref(cell) [lindex $ref(cellreflbl) 1]
    } else {
	set ref(cell) [lindex $ref(cellreflbl) 0]
    }
    
    # set refinement flags from inital codewords
    foreach varnam {SCALE Q U V W Z EX} {
	if {$refval($varnam) != 0.0} {
	    set vflag($varnam) 1
	} else {
	    set vflag($varnam) 0
	}
    }

    set ref(DET1) [expr $in(IDET) / 100]
    set ref(DET2) [expr $in(IDET) % 100]
    # the following is not needed as ref(DET1) and  ref(DET2) do not change in the GUI
    #trace variable ref(DET1) w setIDET
    #trace variable ref(DET2) w setIDET


    # set the BKG refinement flags from the 1st value in the refval flags
    for {set i $ref(DET1)} {$i <= $ref(DET2)} {incr i} {
	if {$refval(BG1_$i) != 0.0} {
	    set vflag(BKG$i) 1
	} else {
	    set vflag(BKG$i) 0
	}
    }

    # remove spaces from some displayed variables for pretty formatting
    foreach v {ATOM TYPE FORM EQUIV ROT} {
	set in($v) [string trim $in($v)]
    }
    foreach atom $ref(atomlist) {
	foreach v "NTYP${atom} MTYP${atom} MROT${atom}" {
	    set in($v) [string trim $in($v)]
	}
    }
}

proc LoadRefine {top} {
    global prep
    refinebox $top
    ReadRefineFile $prep(rootname)
    initalizeatoms
    setatomsvflags
    initgui
    testAllBkg
}

proc RunRefine {top} {
    global prep refgui tcl_platform
    setCodeWords
    WriteRefineFile $prep(rootname)
    # here we run REFINE
    set fp [open refine.inp w]
    puts $fp 3
    puts $fp 9
    close $fp
    forknewterm "Run Refine" "$refgui(rietveld) $prep(rootname)" refine.inp
    if {$tcl_platform(platform) == "windows"} {
	tk_dialog .err "Wait for refinement" \
		"Press OK when REFINE is done" \
		"" 0 "OK"
    }
    set fp [open $prep(rootname).PRR r]
    set tmp [read $fp]
    close $fp
    # get rid of first control character
    set text {}
    append text { } [string range $tmp 1 end]
    # fix up rest
    regsub -all "\n0" $text "\n\n " text
    regsub -all "\n1" $text \
	    "\n---------------- (new page) -------------------------------------------\n " text
    ShowBigMessage .out "REFINE output" $text
    buttonbar $top
}